#ifndef _ENGINE_CORE_COLLECTIONS_HASHSTRING_HPP
#define _ENGINE_CORE_COLLECTIONS_HASHSTRING_HPP

#include "../../dllconfig.hpp"
#include "ConstCharWrapper.hpp"

#define FNV1A_BASE 2166136261u
#define FNV1A_PRIME 16777619u

namespace Engine
{
	namespace Core
	{
		namespace Collections
		{
			class HashString
			{
			public:
				HashString(ConstCharWrapper _str) : hash(FNV1a(_str.Str()))
				{ }
				
				template<size_t N> inline HashString(const char (&_str)[N]) : hash(FNV1a<N>(_str))
				{ }

				const size_t Hash() const
				{
					return hash;
				}

			private:
				template <size_t N> inline size_t FNV1a(const char* _str)
				{
					return (FNV1a<N-1>(_str + 1) ^ _str[0]) * FNV1A_PRIME;
				}
				template <> inline size_t FNV1a<1>(const char* _str)
				{
					return FNV1A_BASE;
				}
				inline size_t FNV1a(const char* _str)
				{
					if (_str[0] == '\0')
						return FNV1A_BASE;
					else
						return (FNV1a(_str + 1) ^ (_str[0])) * FNV1A_PRIME;
				}

				size_t hash;

			};
		}
	}
}

#include "UnorderedMapExtensions.hpp"

#endif