#ifndef _ENGINE_CORE_CONCURRENCY_ATOMICARRAY_HPP
#define _ENGINE_CORE_CONCURRENCY_ATOMICARRAY_HPP

#include "../../dllconfig.hpp"
#include <Windows.h>

namespace Engine
{
	namespace Core
	{
		namespace Concurrency
		{
			template <typename T, unsigned Size = sizeof(T)>
			class AtomicArray
			{
			public:
				AtomicArray(unsigned int _elements);
				~AtomicArray();

				void Reserve(unsigned int _size);

				inline T CompareExchange(const unsigned int _index, const T& _exchange, const T& _compare) const;
				inline T Exchange(const unsigned int _index, const T& _exchange) const;

				inline T Increment(const unsigned int _index);
				inline T Decrement(const unsigned int _index);

				inline const T& operator[] (const unsigned int _index) const;
				inline T& operator[] (const unsigned int _index);

				unsigned int Size() const;
			};
		}
	}
}

#include "AtomicArray32.hpp"
#include "AtomicArray64.hpp"

#endif