#define DLL_EXPORT

#include "Event.hpp"
#include "../../Util/Logger.hpp"

using namespace Engine::Core::Concurrency;
using namespace Engine::Util;

Event::Event()
{
	handle = CreateEvent(NULL, false, false, NULL);
}

Event::Event(bool _manualReset)
{
	handle = CreateEvent(NULL, _manualReset, false, NULL);
}

Event::Event(bool _manualReset, bool _state)
{
	handle = CreateEvent(NULL, _manualReset, _state, NULL);
}

Event::~Event()
{
	CloseHandle(handle);
}

void Event::Set() const
{
	SetEvent(handle);
}

void Event::Reset() const
{
	ResetEvent(handle);
}

void Event::Wait() const
{
	DWORD result = WaitForSingleObject(handle, INFINITE);

	if (result == WAIT_FAILED)
		Logger::Fatal("Wait failed");
}

bool Event::IsSet() const
{
	DWORD result = WaitForSingleObject(handle, 0);

	if (result == WAIT_FAILED)
		Logger::Fatal("Wait failed");
	else if (result == WAIT_OBJECT_0)
		return true;

	return false;
}
