#ifndef _ENGINE_CORE_CONCURRENCY_LOCKABLE_HPP
#define _ENGINE_CORE_CONCURRENCY_LOCKABLE_HPP

#include "../../dllconfig.hpp"
#include "ThreadManager.hpp"

#include <Windows.h>

typedef unsigned int LockableID;

namespace Engine
{
	namespace Core
	{
		namespace Concurrency
		{
			class _DLL_DECLSPEC Lockable
			{
			public:
				Lockable();
				~Lockable();

				void Lock();
				bool TryLock();
				void Unlock();

			private:
				CRITICAL_SECTION section;
				volatile static LockableID nextLockID;
				const LockableID lockID;
			};
		}
	}
}

#endif