#define DLL_EXPORT

#include "ThreadManager.hpp"

using namespace Engine::Core::Concurrency;

unsigned long ThreadManager::tlsIndex = TLS_OUT_OF_INDEXES;

void ThreadManager::RegisterThread()
{
	//Logger::Message("Registering new Thread");

	LockList* ll = new LockList();
	ll->reserve(5);

	TLSData* data = (TLSData*)TlsGetValue(ThreadManager::tlsIndex);
	data->lockedObjects = ll;
	data->tmpSSEMemory[0] = _aligned_malloc(2 * 128, 16);
	data->tmpSSEMemory[1] = (void*)((char*)data->tmpSSEMemory[0] + (128 / sizeof(char)));
}

void ThreadManager::ReleaseThread()
{
	TLSData* data = (TLSData*)TlsGetValue(ThreadManager::tlsIndex);

	if (data != NULL)
	{
		delete data->lockedObjects;
		_aligned_free(data->tmpSSEMemory[0]);
	}
}

unsigned int ThreadManager::ThreadID()
{
	return (unsigned int)GetCurrentThreadId();
}

LockList* ThreadManager::LockedObjects()
{
	TLSData* td = (TLSData*)TlsGetValue(ThreadManager::tlsIndex);
	return td->lockedObjects;
}