#ifndef _ENGINE_CORE_CONCURRENCY_THREADMANAGER
#define _ENGINE_CORE_CONCURRENCY_THREADMANAGER

#include "../../dllconfig.hpp"
#include "TLSData.hpp"
#include <Windows.h>

namespace Engine
{
	namespace Core
	{
		namespace Concurrency
		{
			class _DLL_DECLSPEC ThreadManager
			{
			public:
				static unsigned int ThreadID();
				static LockList* LockedObjects();
				
				static void RegisterThread();
				static void ReleaseThread();

				template <typename T, unsigned int blockNumber> static inline T* tmpSSEMemory()
				{
					TLSData* data = (TLSData*)TlsGetValue(ThreadManager::tlsIndex);
					void *block = data->tmpSSEMemory[blockNumber];
					return (T*)block;
				}

				static unsigned long tlsIndex;
			};
		}
	}
}

#endif