#ifndef _ENGINE_CORE_CONTROL_RENDERCONTROL_HPP
#define _ENGINE_CORE_CONTROL_RENDERCONTROL_HPP

#include "../../dllconfig.hpp"
#include "../../Prototypes.hpp"
#include <Windows.h>
#include "../IO/KeyboardInput.hpp"
#include "../IO/MouseInput.hpp"
#include "../../Core/EventHandling/Event.hpp"

namespace Engine
{
	namespace Core
	{
		namespace Control
		{
			class _DLL_DECLSPEC RenderControl
			{
			public:
				RenderControl(unsigned int _height, unsigned int _width);
				virtual ~RenderControl();

				void SwapBuffer();

				unsigned int Height();
				void Height(unsigned int _height);
				unsigned int Width();
				void Width(unsigned int _width);

				Graphic::GraphicContext* Context() const;
				IO::KeyboardInput& Keyboard();
				IO::MouseInput& Mouse();

				bool HasMouseFocus() const;
				void HasMouseFocus(bool _focus);

				void Init(HWND _hwnd);
				void Resize(unsigned int _height, unsigned int _width);

				//Debugoutput
				bool ShowTimes() const;
				void ShowTimes(bool _value);
				bool ShowBoundings() const;
				void ShowBoundings(bool _value);
				bool ShowLightVolumes() const;
				void ShowLightVolumes(bool _value);
				bool ShowTonemapper() const;
				void ShowTonemapper(bool _value);
				bool ShowBloom() const;
				void ShowBloom(bool _value);
				bool ShowFXAA() const;
				void ShowFXAA(bool _value);

				Core::EventHandling::Event<Core::EventHandling::EventArgs> SizeChanged;

			private:
				Graphic::GraphicContext* context;

				IO::KeyboardInput keyboard;
				IO::MouseInput mouse;
				bool hasMouseFocus;

				unsigned int height, width;

				bool showTimes, showBoundings, showLightVolumes, showTonemapper, showBloom, showFXAA;
			};
		}
	}
}

#endif