#ifndef _ENGINE_CORE_CONTROL_SYSTEMCONSOLE_HPP
#define _ENGINE_CORE_CONTROL_SYSTEMCONSOLE_HPP

#include "../../dllconfig.hpp"
#include "../../Prototypes.hpp"
#include <Windows.h>

namespace Engine
{
	namespace Core
	{
		namespace Control
		{
			enum ConsoleColor : WORD
			{
				DefaultConsoleColor = FOREGROUND_RED | FOREGROUND_GREEN,
				DarkGrayConsoleColor= FOREGROUND_BLUE,
				WhiteConsoleColor	= FOREGROUND_GREEN,
				RedConsoleColor		= FOREGROUND_GREEN | FOREGROUND_BLUE,
				BlueConsoleColor	= FOREGROUND_RED | FOREGROUND_BLUE,
				GreenConsoleColor	= FOREGROUND_RED,
				BlackConsoleColor   = 0,
				YellowConsoleColor	= FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE,
				GrayConsoleColor	= FOREGROUND_INTENSITY,

				UndefinedConsoleColor1		= FOREGROUND_GREEN | FOREGROUND_INTENSITY,
				UndefinedConsoleColor2		= FOREGROUND_BLUE | FOREGROUND_INTENSITY,
				UndefinedConsoleColor3		= FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_INTENSITY,
				UndefinedConsoleColor4		= FOREGROUND_RED | FOREGROUND_BLUE | FOREGROUND_INTENSITY,
				UndefinedConsoleColor5		= FOREGROUND_BLUE | FOREGROUND_GREEN | FOREGROUND_INTENSITY,
				UndefinedConsoleColor6		= FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE | FOREGROUND_INTENSITY,
				UndefinedConsoleColor7		= FOREGROUND_RED | FOREGROUND_INTENSITY
			};

			class _DLL_DECLSPEC SystemConsole
			{
			public:
				static void OpenConsole();
				static void SetColor(ConsoleColor _color);
				static void PrintInfo();
				static void Focus();

			private:
				static HANDLE hOutputConsole;
				static HWND consoleWindow;
			};
		}
	}
}

#endif