#ifndef _ENGINE_CORE_CONTROL_WINDOW_HPP
#define _ENGINE_CORE_CONTROL_WINDOW_HPP

#include "../../dllconfig.hpp"
#include "RenderControl.hpp"
#include <unordered_map>

namespace Engine
{
	namespace Core
	{
		namespace Control
		{
			class _DLL_DECLSPEC Window : public RenderControl
			{
			public:
				Window(HINSTANCE _hInstance, LPCWSTR _title, unsigned int _width, unsigned int _height);
				virtual ~Window();

				static LRESULT CALLBACK WndProc(HWND _hwnd, UINT _message, WPARAM _wParam, LPARAM _lParam);
				LRESULT ProcessSystemEvent(UINT _message, WPARAM _wParam, LPARAM _lParam);
				static bool CheckMessages(bool& _running);

				void Show();
				void Hide();

			private:
				static std::unordered_map<HWND, Window*> windowLookupTable;

				HWND hwnd;
				
			};
		}
	}
}

#endif