#ifndef _ENGINE_UTIL_DEBUGGING_CPUINFORMATION_HPP
#define _ENGINE_UTIL_DEBUGGING_CPUINFORMATION_HPP

#include "../../dllconfig.hpp"
#include <string>

namespace Engine
{
	namespace Core
	{
		namespace Hardware
		{
			class _DLL_DECLSPEC CPUInformation
			{
			public:
				static void Print();

				static bool HasSSE41Extensions();

			private:

				static void PrintBool(bool _value, std::string _trueText, std::string _falseText);
				static void Init();

				static char cpuString[32];
				static char cpuBrandString[64];

				static int nLogicalProcessors;
				static int nCacheLineSize;
				static int nL2Associativity;
				static int nCacheSizeK;
				static int nFeatureInfo;

				static bool    sse1Support;
				static bool    sse2Support;
				static bool    sse3Support;
				static bool    supplementalSSE3Support;
				static bool    sse41Support;
				static bool    sse42Support;
				static bool    misalignedSSESupport;
				static bool    mmxSupport;
				static bool    multithreading;

				static unsigned int nIds;
				static unsigned int nExIds;
				static unsigned int i;

				//This is needed for creating a static ctor
				class Initializer
				{
				public:
					Initializer();
				};
				friend class Initializer;
				static Initializer init;
			};
		}
	}
}

#endif