#include "SSEInstructions.hpp"

#ifdef USE_SSE4_REPLACEMENTS

__m128 sse_dp_ps_internal(__m128 _a, __m128 _b, const int _mask)
{
	float maskFloat[8]; 
	for (int i = 0; i < 8; i++) 
		maskFloat[i] = ((_mask & (1 << i)) != 0) ? 1.0f : 0.0f;
		
	__m128 mask1 = _mm_loadu_ps(maskFloat);
	__m128 mask2 = _mm_loadu_ps(maskFloat + 4);
		
	__m128 r1 = _mm_mul_ps(_a, _b);
	r1 = _mm_mul_ps(r1, mask2);
	__m128 r2 = _mm_hadd_ps(r1, r1);
	__m128 r3 = _mm_hadd_ps(r2, r2);
	r3 = _mm_mul_ps(r3, mask1);
	return r3;
}

#endif