#define DLL_EXPORT

#include "KeyboardInput.hpp"

using namespace Engine;
using namespace Engine::Core;
using namespace Engine::Core::IO;

KeyboardInput::KeyboardInput()
{
	for (int i = 0; i < 256; i++)
		state[i] = KeyState::KeyReleased;
}

KeyboardInput::~KeyboardInput()
{ }

void KeyboardInput::KeyMessage(WPARAM _data1, LPARAM _data2, bool _isPressed)
{
	if (_isPressed)
		state[_data1] = KeyState::KeyDown;
	else
		state[_data1] = KeyState::KeyUp;
}

void KeyboardInput::KeyMessage(int _data1, bool _isPressed)
{
	if (_isPressed)
		state[_data1] = KeyState::KeyDown;
	else
		state[_data1] = KeyState::KeyUp;
}

void KeyboardInput::InitFrame()
{
	for (int i = 0; i < 256; i++)
	{
		if (state[i] == KeyState::KeyDown)
			state[i] = KeyState::KeyPressed;
		else if (state[i] == KeyState::KeyUp)
			state[i] = KeyState::KeyReleased;
	}
}

bool KeyboardInput::IsKeyDown(Keys _key) const
{
	return (state[_key] == KeyState::KeyDown);
}
bool KeyboardInput::IsKeyUp(Keys _key) const
{
	return (state[_key] == KeyState::KeyUp);
}
bool KeyboardInput::IsKeyPressed(Keys _key) const
{
	return (state[_key] == KeyState::KeyDown) || (state[_key] == KeyState::KeyPressed);
}

Keys KeyboardInput::KeyFromChar(char _char)
{
	return Keys::A;
}