#ifndef _ENGINE_CORE_IO_KEYBOARDINPUT_HPP
#define _ENGINE_CORE_IO_KEYBOARDINPUT_HPP

#include "../../dllconfig.hpp"
#include <Windows.h>
#include "Keys.hpp"

namespace Engine
{
	namespace Core
	{
		namespace IO
		{
			enum KeyState : unsigned char
			{
				KeyDown, KeyPressed, KeyUp, KeyReleased
			};

			class _DLL_DECLSPEC KeyboardInput
			{
			public:
				KeyboardInput();
				~KeyboardInput();

				void InitFrame();
				void KeyMessage(WPARAM _data1, LPARAM _data2, bool _isPressed);
				void KeyMessage(int _data1, bool _isPressed);

				bool IsKeyDown(Keys _key) const;
				bool IsKeyUp(Keys _key) const;
				bool IsKeyPressed(Keys _key) const;

				static Keys KeyFromChar(char _char);

			private:
				KeyState state[256];
			};
		}
	}
}

#endif