#ifndef _ENGINE_CORE_IO_KEYS_HPP
#define _ENGINE_CORE_IO_KEYS_HPP

namespace Engine
{
	namespace Core
	{
		namespace IO
		{
			enum Keys : unsigned char
			{
				A = 0x41,
				B = 0x42,
				C = 0x43,
				D = 0x44,
				E = 0x45,
				F = 0x46,
				G = 0x47,
				H = 0x48,
				I = 0x49,
				J = 0x4A,
				K = 0x4B,
				L = 0x4C,
				M = 0x4D,
				N = 0x4E,
				O = 0x4F,
				P = 0x50,
				Q = 0x51,
				R = 0x52,
				S = 0x53,
				T = 0x54,
				U = 0x55,
				V = 0x56,
				W = 0x57,
				X = 0x58,
				Y = 0x59,
				Z = 0x5A,

				Key0 = 0x30,
				Key1 = 0x31,
				Key2 = 0x32,
				Key3 = 0x33,
				Key4 = 0x34,
				Key5 = 0x35,
				Key6 = 0x36,
				Key7 = 0x37,
				Key8 = 0x38,
				Key9 = 0x39,

				F1 = VK_F1,
				F2 = VK_F2,
				F3 = VK_F3,
				F4 = VK_F4,
				F5 = VK_F5,
				F6 = VK_F6,
				F7 = VK_F7,
				F8 = VK_F8,
				F9 = VK_F9,
				F10 = VK_F10,
				F11 = VK_F11,
				F12 = VK_F12,

				Numpad0 = 0x60,
				Numpad1 = 0x61,
				Numpad2 = 0x62,
				Numpad3 = 0x63,
				Numpad4 = 0x64,
				Numpad5 = 0x65,
				Numpad6 = 0x66,
				Numpad7 = 0x67,
				Numpad8 = 0x68,
				Numpad9 = 0x69,

				Add = 0x6B,
				Subtract = 0x6D,
				Multiply = 0x6A,
				Divide = 0x6F,

				Shift = VK_SHIFT,
				ShiftL = VK_LSHIFT,
				ShiftR = VK_RSHIFT,
				Ctrl = VK_CONTROL,
				CtrlL = VK_LCONTROL,
				CtrlR = VK_RCONTROL,
				Alt = VK_MENU,
				Escape = VK_ESCAPE
			};
		}
	}	
}

#endif