#ifndef _ENGINE_CORE_IO_MEMORYREADER_HPP
#define _ENGINE_CORE_IO_MEMORYREADER_HPP

#include "../../dllconfig.hpp"
#include <cstring>

namespace Engine
{
	namespace Core
	{
		namespace IO
		{
			class _DLL_DECLSPEC MemoryReader
			{
			public:
				MemoryReader(byte* _data, std::size_t _size) : data(_data), size(_size), currentValue(_data) { }
				~MemoryReader() { }

				template <typename T> inline T Read()
				{
					byte* val = currentVal;
					currentVal += sizeof(T);
					return *(T*)val;
				}

				template <typename T> inline T* ReadArray(std::size_t _numberOfElements)
				{
					byte* val = currentVal;
					currentVal += (sizeof(T) * _numberofElements);
					return (T*)val;
				}

			private:
				byte* data;
				std::size_t size;
				byte* currentValue;
			};
		}
	}
}

#endif