#ifndef _ENGINE_CORE_MEMORY_HEAPALLOCATOR_HPP
#define _ENGINE_CORE_MEMORY_HEAPALLOCATOR_HPP

#include "Allocator.hpp"
#include <malloc.h>
#include <cassert>
#include <iostream>

namespace Engine
{
	namespace Core
	{
		namespace Memory
		{
			class _DLL_DECLSPEC HeapAllocator : public Allocator
			{
			public:
				HeapAllocator();
				virtual ~HeapAllocator();
				

				virtual void Free(void* _data);
				
				virtual void FreeArray(void* _data);

			private:
				virtual void* InternalAlloc(unsigned int _size, unsigned int _alignment);
				
				virtual void* InternalAllocArray(unsigned int _elementSize, unsigned int _count, unsigned int _alignment);

			};
		}
	}
}

#endif