#ifndef _ENGINE_CORE_MEMORY_STACKALLOCATOR_HPP
#define _ENGINE_CORE_MEMORY_STACKALLOCATOR_HPP

#include "../../dllconfig.hpp"
#include "Allocator.hpp"

namespace Engine
{
	namespace Core
	{
		namespace Memory
		{
			class _DLL_DECLSPEC StackAllocator : public Allocator
			{
			public:
				StackAllocator(unsigned int _size, Allocator& _allocator = Allocator::DefaultAllocator(), unsigned int _alignment = 1);
				virtual ~StackAllocator();

				virtual void Free(void* _data);
				virtual void FreeArray(void* _data);
			
			private:
				virtual void* InternalAlloc(unsigned int _size, unsigned int _alignment);
				virtual void* InternalAllocArray(unsigned int _elementSize, unsigned int _count, unsigned int _alignment);

				Allocator& allocator;
				unsigned int size;
				byte* data;
				byte* freePointer;
			};
		}
	}
}

#endif