#define DLL_EXPORT

#include "SystemConfiguration.hpp"
#include <Windows.h>
#include <stdlib.h>
#include <malloc.h>

using namespace Engine;
using namespace Engine::Core;
using namespace Engine::Core::Collections;
using namespace Engine::Core::System;
using namespace Engine::Core::IO;

std::unordered_map<HashString, void*> SystemConfiguration::configValues;

SystemConfiguration::Initializer SystemConfiguration::init;


//This is a workaround for the non existing static ctor in c++ ...
SystemConfiguration::Initializer::Initializer()
{
	//Load configuration
	SystemConfigurationReader::Load();

	//Load defaultFontPath
	TCHAR winDirPath[MAX_PATH];
	GetWindowsDirectory(winDirPath, MAX_PATH);
	size_t bufferLen = wcstombs(nullptr, winDirPath, 0) + 1;
	char* buffer = new char[bufferLen];
	wcstombs(buffer, winDirPath, bufferLen);

	std::string* path = new std::string(buffer);
	std::string* oldpath = GetPointer<std::string>("DefaultFontPath");
	path->append("\\Fonts\\").append(*oldpath);
	configValues["DefaultFontPath"] = path;
	delete oldpath;
}

SystemConfiguration::Initializer::~Initializer()
{
	for(auto it = configValues.begin(); it != configValues.end(); it++)
		delete it->second;

	configValues.clear();
}