#define DLL_EXPORT

#include "PositionUpdateTask.hpp"
#include "../SystemConfiguration.hpp"
#include "../../../Scene/SceneObject.hpp"
#include "../../../Scene/Components/PositionComponent.hpp"

using namespace Engine;
using namespace Engine::Scene;
using namespace Engine::Scene::Components;
using namespace Engine::Core::System;
using namespace Engine::Core::System::Tasks;

void PositionUpdateTask::Process(const std::vector<PositionComponent*>& _positionComponents, unsigned int _threadId)
{
	for (unsigned int i = _threadId; i < _positionComponents.size(); i += SystemConfiguration::Get<unsigned int>("WorkerThreadCount"))
	{
		PositionComponent* currentPC = _positionComponents[i];

		if (currentPC->NeedUpdate()) //Only when this component needs updates
		{
			if (currentPC->ParentPositionComponent() != nullptr)
			{
				int i = 0;
				while (currentPC->ParentPositionComponent()->NeedUpdate())
				{ } //Spin and wait until parent is finished
			}

			//Now update this component
			currentPC->Update();
		}
	}
}