#define DLL_EXPORT

#include "UpdateTask.hpp"
#include "../../../Scene/World.hpp"
#include "../SystemConfiguration.hpp"
#include "../../../Scene/Components/IComponent.hpp"
#include <algorithm>

using namespace Engine;
using namespace Engine::Core;
using namespace Engine::Core::System;
using namespace Engine::Core::System::Tasks;

void UpdateTask::Process(const std::vector<Scene::Components::IComponent*> _components, unsigned int _threadId)
{
	size_t componentsPerThread = _components.size() / SystemConfiguration::Get<unsigned int>("WorkerThreadCount") + 1;
	size_t startIdx = _threadId * componentsPerThread;
	size_t endIdx = std::min<size_t>((_threadId + 1) * componentsPerThread, _components.size());


	for (size_t i = startIdx; i < endIdx; ++i)
	{
		_components[i]->Update();
	}
}