#ifndef _ENGINE_GRAPHIC_BASICBODIES_CONE_HPP
#define _ENGINE_GRAPHIC_BASICBODIES_CONE_HPP

#include "../../dllconfig.hpp"
#include <gl\glew.h>
#include "../../Math/Math.hpp"

namespace Engine
{
	namespace Graphic
	{
		class GraphicContext;

		namespace BasicBodies
		{
			class _DLL_DECLSPEC Cone
			{
			public:
				Cone(GraphicContext* _context);
				~Cone();

				static Math::Mat4f CreateMatrix(float _angle, float _height);
				void Draw(GLenum _primitiveType) const;

			private:
				GraphicContext* context;
				GLuint vbo, indexVbo, vao;
			};
		}
	}
}

#endif