#ifndef _ENGINE_GRAPHIC_BASICBODIES_ICOSPHERE_HPP
#define _ENGINE_GRAPHIC_BASICBODIES_ICOSPHERE_HPP

#include "../../dllconfig.hpp"
#include <gl\glew.h>
#include "../../Math/Math.hpp"

namespace Engine
{
	namespace Graphic
	{
		class GraphicContext;

		namespace BasicBodies
		{
			class _DLL_DECLSPEC IcoSphere
			{
			public:
				IcoSphere(GraphicContext* _context);
				~IcoSphere();

				void Draw(GLenum _primitiveType) const;
				static Math::Mat4f CreateMatrix(float _radiusInscribedSphere);

			private:
				GraphicContext* context;
				GLuint vbo, indexVbo, vao;
			};
		}
	}
}

#endif