#define DLL_EXPORT

#include "AtomicCounterBuffer.hpp"

using namespace Engine;
using namespace Engine::Graphic;
using namespace Engine::Graphic::Buffers;

AtomicCounterBuffer::AtomicCounterBuffer() : Buffer(GL_ATOMIC_COUNTER_BUFFER, sizeof(GLuint), 0, GL_STREAM_DRAW)
{
	Set(0);
}


AtomicCounterBuffer::AtomicCounterBuffer(GLuint _initialValue) : Buffer(GL_ATOMIC_COUNTER_BUFFER, sizeof(GLuint), &_initialValue, GL_STREAM_DRAW)
{ }

AtomicCounterBuffer::~AtomicCounterBuffer()
{ }

void AtomicCounterBuffer::Bind(GLuint _location) const
{
	glBindBufferBase(GL_ATOMIC_COUNTER_BUFFER, _location, Handle());
}

void AtomicCounterBuffer::Set(GLuint _value) const
{
	GLuint* ptr = (GLuint*)MapWrite(GL_ATOMIC_COUNTER_BUFFER);
	ptr[0] = _value;
	Unmap(GL_ATOMIC_COUNTER_BUFFER);
}