#ifndef _ENGINE_GRAPHIC_BUFFERS_BUFFER_HPP
#define _ENGINE_GRAPHIC_BUFFERS_BUFFER_HPP

#include "../../dllconfig.hpp"
#include "../../Prototypes.hpp"

#include <gl\glew.h>

namespace Engine
{
	namespace Graphic
	{
		namespace Buffers
		{
			class _DLL_DECLSPEC Buffer
			{
			public:
				static void Copy(const Buffer& _source, const Buffer& _target, GLintptr _readOffset, GLintptr _writeOffset, GLsizeiptr _size);

			protected:
				Buffer();
				Buffer(GLenum _target, GLsizei _size, const GLvoid* _data, GLenum _usage);
				~Buffer();

				void Bind(GLenum _target) const;
				void Unbind(GLenum _target) const;

				void* MapRead(GLenum _target) const;
				void* MapWrite(GLenum _target) const;
				void Unmap(GLenum _target) const;

				GLuint Handle() const;
				GLsizei Size() const;

			private:
				GLsizei size;
				GLuint handle;
			};
		}
	}
}

#endif