#define DLL_EXPORT

#include "IndirectDrawBuffer.hpp"

using namespace Engine;
using namespace Engine::Graphic;
using namespace Engine::Graphic::Buffers;

IndirectDrawBuffer::IndirectDrawBuffer() : Buffer(GL_DRAW_INDIRECT_BUFFER, 4 * sizeof(GLuint), 0, GL_STREAM_DRAW)
{ }

IndirectDrawBuffer::~IndirectDrawBuffer()
{ }

void IndirectDrawBuffer::BindAtomicCounter(GLuint _location) const
{
	glBindBufferBase(GL_ATOMIC_COUNTER_BUFFER, _location, Handle());
}

void IndirectDrawBuffer::BindIndirectDraw() const
{
	Bind(GL_DRAW_INDIRECT_BUFFER);
}

void IndirectDrawBuffer::Set(GLuint _count, GLuint _instances, GLuint _first, GLuint _baseInstance) const
{
	GLuint* ptr = (GLuint*)MapWrite(GL_DRAW_INDIRECT_BUFFER);
	ptr[0] = _count;
	ptr[1] = _instances;
	ptr[2] = _first;
	ptr[3] = _baseInstance;
	Unmap(GL_DRAW_INDIRECT_BUFFER);
}