#ifndef _ENGINE_GRAPHIC_BUFFERS_SHADERSTORAGEBUFFER_HPP
#define _ENGINE_GRAPHIC_BUFFERS_SHADERSTORAGEBUFFER_HPP

#include "../../dllconfig.hpp"
#include "../../Prototypes.hpp"

#include <gl\glew.h>

namespace Engine
{
	namespace Graphic
	{
		namespace Buffers
		{
			class _DLL_DECLSPEC ShaderStorageBuffer
			{
			public:
				ShaderStorageBuffer();
				~ShaderStorageBuffer();

				void Bind(GLuint _location) const;
				void BufferData(GLvoid* _data, unsigned int _size, GLenum _usage) const;
				void BufferSubData(GLvoid* _data, unsigned int _offset, unsigned int _size) const;

				GLvoid* MapMemory(GLenum _access) const;
				void UnMapMemory() const;

				void Clear(const void* _data, GLenum _internalFormat, GLenum _format, GLenum _type) const;

			private:
				GLuint handle;
			};
		}
	}
}

#endif