#ifndef _ENGINE_GRAPHIC_BUFFERS_TEXTURE3D_HPP
#define _ENGINE_GRAPHIC_BUFFERS_TEXTURE3D_HPP

#include "../../dllconfig.hpp"
#include <gl\glew.h>

namespace Engine
{
	namespace Graphic
	{
		namespace Buffers
		{
			class _DLL_DECLSPEC Texture3D
			{
			public:
				Texture3D(GLenum _internalFormat, GLenum _format, bool _generateMipmaps);
				~Texture3D();

				void Bind(GLint _textureUnit) const;
				void BindImage(GLint _textureUnit) const;

				void BufferImage(unsigned int _width, unsigned int _height, unsigned int _depth, GLenum _type = GL_FLOAT, GLvoid* _data = nullptr);
				void BufferSubImage(unsigned int _xoffset, unsigned int _yoffset, unsigned int _zoffset, unsigned int _width, unsigned int _height, unsigned int _depth, GLenum _type, GLvoid* _data);

				void SetWrap(GLint _wrapX, GLint _wrapY = GL_REPEAT, GLint _wrapZ = GL_REPEAT) const;
				void SetFilter(GLint _minFilter, GLint _magFilter) const;

				void GenerateMipmaps() const;

				GLuint Handle() const;

			private:
				GLuint handle;

				GLenum internalFormat, format;
				bool generateMipmaps;
			};
		}
	}
}

#endif