#ifndef _ENGINE_GRAPHIC_BUFFERS_TEXTUREBUFFER_HPP
#define _ENGINE_GRAPHIC_BUFFERS_TEXTUREBUFFER_HPP

#include "../../dllconfig.hpp"
#include "../../Prototypes.hpp"
#include <gl\glew.h>

namespace Engine
{
	namespace Graphic
	{
		namespace Buffers
		{
			class _DLL_DECLSPEC TextureBuffer
			{
			public:
				TextureBuffer(GLenum _format);
				~TextureBuffer();

				void Bind(GLuint _location, GLenum _access) const;
				void BufferData(GLvoid* _data, unsigned int _size, GLenum _usage) const;
				void BufferSubData(GLvoid* _data, unsigned int _offset, unsigned int _size) const;

				GLvoid* MapMemory(GLenum _access) const;
				void UnMapMemory() const;

				void Clear(const void* _data, GLenum _format, GLenum _type) const;

			private:
				GLuint handleTexture, handleBuffer;
				GLenum format, type;
			};
		}
	}
}

#endif