#define DLL_EXPORT

#include "IDelayedValue.hpp"
#include "IDelayedValueObserver.hpp"
#include <cassert>

using namespace Engine::Graphic::DelayedChange;

IDelayedValue::IDelayedValue(IDelayedValueObserver* _observer) : observer(_observer), isChanged(false)
{ }

IDelayedValue::~IDelayedValue()
{ }

void IDelayedValue::ChangeValue()
{
	this->DoChangeValue();
	isChanged = false;
}

void IDelayedValue::OnNotifyValueChanged()
{
	if (!isChanged)
	{
		isChanged = true;
		observer->NotifyValueChanged(this);
	}
}

bool IDelayedValue::IsChanged()
{
	return isChanged;
}

IDelayedValueObserver* IDelayedValue::Observer()
{
	return observer;
}