#ifndef _ENGINE_GRAPHIC_DELAYEDCHANGE_IDELAYEDVALUE_HPP
#define _ENGINE_GRAPHIC_DELAYEDCHANGE_IDELAYEDVALUE_HPP

#include "../../dllconfig.hpp"

namespace Engine
{
	namespace Graphic
	{
		namespace DelayedChange
		{
			class IDelayedValueObserver;

			class _DLL_DECLSPEC IDelayedValue
			{
			public:
				IDelayedValue(IDelayedValueObserver* _observer);
				virtual ~IDelayedValue();

				void ChangeValue();

			protected:
				virtual void DoChangeValue() = 0;
				void OnNotifyValueChanged();
				bool IsChanged();

				IDelayedValueObserver* Observer();
				
			private:
				bool isChanged;
				IDelayedValueObserver* observer;
			};
		}
	}
}

#endif