#ifndef _ENGINE_GRAPHIC_EFFECTS_SPOTLIGHTEFFECT
#define _ENGINE_GRAPHIC_EFFECTS_SPOTLIGHTEFFECT

#include "../../dllconfig.hpp"
#include "../../Prototypes.hpp"
#include "../../Graphic/Shaders/Shader.hpp"

namespace Engine
{
	namespace Scene { namespace Cameras { class RenderCamera; } }

	namespace Graphic
	{
		namespace Effects
		{
			class _DLL_DECLSPEC SpotLightEffect
			{
			public:
				SpotLightEffect(const Scene::Cameras::Camera& _camera, GraphicContext* _context);
				~SpotLightEffect();

				void Render(const Scene::Lights::SpotLight* _light);

			private:
				static ShaderPtr* shaderPtr; //This is used as a singleton shader loader
				ShaderPtr shader;

				GraphicContext* context;
				const Scene::Cameras::Camera& camera;
			};
		}
	}
}

#endif