#ifndef _ENGINE_GRAPHIC_EFFECTS_TONEMAPEFFECT
#define _ENGINE_GRAPHIC_EFFECTS_TONEMAPEFFECT

#include "../../dllconfig.hpp"
#include "../../Prototypes.hpp"

#include "../Buffers/Texture2D.hpp"
#include "../../Graphic/Shaders/Shader.hpp"

#include <gl\glew.h>

namespace Engine
{
	namespace Graphic
	{
		namespace Effects
		{
			class _DLL_DECLSPEC TonemapEffect
			{
			public:
				TonemapEffect(GraphicContext* _context, unsigned int _width, unsigned int _height, const Buffers::Texture2D& _inputTexture, const FrameBuffers::FrameBuffer& _renderBuffer);
				~TonemapEffect();
				
				void Render(float _frameTime);
				void Resize(unsigned int _width, unsigned int _height);

			private:
				float maxLuminance;
				float middleGray;
				float adaptionSpeed;
				unsigned int mipmapLevel;

				
				FrameBuffers::FrameBuffer* avgBuffers[2];
				Buffers::Texture2D* avgTextures[2];
				unsigned int targetBuffer;

				const Buffers::Texture2D& inputTexture;
				const FrameBuffers::FrameBuffer& renderBuffer;

				static ShaderPtr* luminanceUpdateShaderPtr;
				ShaderPtr luminanceUpdateShader;
				static ShaderPtr* tonemapShaderPtr;
				ShaderPtr tonemapShader;

				GraphicContext* context;
			};
		}
	}
}

#endif