#ifndef _ENGINE_GRAPHIC_FONTRENDERER_HPP
#define _ENGINE_GRAPHIC_FONTRENDERER_HPP

#include "../dllconfig.hpp"
#include "../Prototypes.hpp"
#include "../Math/Math.hpp"

#include <gl/glew.h>
#include <string>


namespace Engine
{
	class EngineManager;

	namespace Graphic
	{
		class _DLL_DECLSPEC FontRenderer
		{
		public:
			FontRenderer(const std::string _fontPath, EngineManager* _engineManager, unsigned int _maxCharSize = 64);
			~FontRenderer();

			void RenderString(std::string _text, unsigned int _left, unsigned int _top, const Math::Vec3f& _color);

		private:
			GraphicContext* context;
			
			GLuint fontTextureHandle;
			Math::Mat4f projectionMatrix;

			int charLeft[256];
			int charTop[256];
			int advanceLeft[256];
			int advanceTop[256];

			unsigned int charSize;
			GLuint vbo, vao;

			struct CharacterData
			{
				Math::Vec2f position;
				GLuint charIndex;
			};

			void RenderControl_SizeChanged(void* _sender, Core::EventHandling::EventArgs& _args);
		};
	}
}

#endif