#ifndef _ENGINE_GRAPHIC_FRAMEBUFFERS_FRAMEBUFFER_HPP
#define _ENGINE_GRAPHIC_FRAMEBUFFERS_FRAMEBUFFER_HPP

#include "../../dllconfig.hpp"
#include "../../Prototypes.hpp"
#include <gl\glew.h>
#include <vector>

namespace Engine
{
	namespace Graphic
	{
		namespace FrameBuffers
		{
			class _DLL_DECLSPEC FrameBuffer
			{
			public:
				FrameBuffer(GraphicContext* _context, unsigned int _width, unsigned int _height);
				FrameBuffer(GraphicContext* _context, unsigned int _width, unsigned int _height, GLuint _handle);
				~FrameBuffer();

				void Bind() const;
				void Unbind() const;

				void Resize(unsigned int _width, unsigned int _height);
				void Clear(GLenum _clearBits = GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT) const;

				void AttachTexture(Buffers::Texture2D* _texture, GLenum _target);
				void Init();

				void Copy(const FrameBuffer& _targetBuffer) const;

				unsigned int Height() const;
				unsigned int Width() const;
				GLuint Handle() const;

			private:
				unsigned int width, height;
				GLuint handle;

				std::vector<Buffers::Texture2D*> attachedTextures;
				GLenum maxAttachment;

				GraphicContext* context;
			};
		}
	}
}

#endif