#ifndef _ENGINE_GRAPHIC_GI_ILLUMINATION_AMBIENTOCCLUSIONILLUMINATIONSTAGE_HPP
#define _ENGINE_GRAPHIC_GI_ILLUMINATION_AMBIENTOCCLUSIONILLUMINATIONSTAGE_HPP

#include "IIlluminationStage.hpp"

#include "../../../Scene/Components/VoxelOctreeComponent.hpp"
#include "../../Shaders/Shader.hpp"

namespace Engine
{
	namespace Graphic
	{
		namespace GI
		{
			namespace Illumination
			{
				class _DLL_DECLSPEC AmbientOcclusionIlluminationStage : public IIlluminationStage
				{
				public:
					AmbientOcclusionIlluminationStage(Scene::Components::VoxelOctreeComponent* _component, GraphicContext* _context);
					virtual ~AmbientOcclusionIlluminationStage();

					void Process(const Math::Mat4f& _inverseCameraMatrix, const Math::Vec3f& _cameraPosition, const FrameBuffers::FrameBuffer& _illuminationBuffer);

					#ifdef _ENGINE_OCTREEE_TIMERS
					Util::GLStopWatch& TotalWatch();
					#endif

				private:
					GraphicContext* context;
					Scene::Components::VoxelOctreeComponent* component;

					Graphic::Shaders::Shader ambientOcclusionShader;

					#ifdef _ENGINE_OCTREEE_TIMERS
					Util::GLStopWatch totalWatch;
					#endif
				};
			}
		}
	}
}

#endif