#ifndef _ENGINE_GRAPHIC_GI_ILLUMINATION_INDIRECTILLUMINATIONSTAGE_HPP
#define _ENGINE_GRAPHIC_GI_ILLUMINATION_INDIRECTILLUMINATIONSTAGE_HPP

#include "../../../dllconfig.hpp"
#include "../../../Prototypes.hpp"

#include "IIlluminationStage.hpp"
#include "../../Buffers/Texture2D.hpp"
#include "../../FrameBuffers/FrameBuffer.hpp"
#include "../../Shaders/Shader.hpp"
#include "../../../Math/Math.hpp"

namespace Engine
{
	namespace Graphic
	{
		namespace GI
		{
			namespace Illumination
			{
				class _DLL_DECLSPEC IndirectIlluminationStage : public IIlluminationStage
				{
				public:
					IndirectIlluminationStage(Scene::Components::VoxelOctreeComponent* _component, GraphicContext* _context);
					virtual ~IndirectIlluminationStage();

					void Process(const Math::Mat4f& _inverseCameraMatrix, const Math::Vec3f& _cameraPosition, const FrameBuffers::FrameBuffer& _illuminationBuffer);

				private:
					GraphicContext* context;
					Scene::Components::VoxelOctreeComponent* component;

					Shaders::Shader lightShader;
					FrameBuffers::FrameBuffer lightBuffer;
					Buffers::Texture2D lightDepth;

					FrameBuffers::FrameBuffer lightAccumulationBuffer;
					Buffers::Texture2D diffuseIllumination;
					Buffers::Texture2D specularIllumination;

					Shaders::Shader indirectShader;
				};
			}
		}
	}
}

#endif