#ifndef _ENGINE_GRAPHIC_GI_OCTREEDATA_HPP
#define _ENGINE_GRAPHIC_GI_OCTREEDATA_HPP

#include "GIData.hpp"

#include "../Buffers/ShaderStorageBuffer.hpp"
#include "../Buffers/TextureBuffer.hpp"
#include "../Buffers/Texture3D.hpp"
#include "../Buffers/IndirectDrawBuffer.hpp"

namespace Engine
{
	namespace Graphic
	{
		namespace GI
		{
			class OctreeData : public GIData
			{
			public:
				OctreeData();
				~OctreeData();

				const Buffers::ShaderStorageBuffer& LinkBuffer() const;
				const Buffers::TextureBuffer& LockBuffer() const;
				const Buffers::Texture3D& BrickTexture() const;

				const Buffers::IndirectDrawBuffer& LevelBuffers(unsigned int _level) const;

				void Resize(unsigned int _entryCount);

			private:
				Buffers::ShaderStorageBuffer linkBuffer;
				Buffers::TextureBuffer lockBuffer;
				Buffers::Texture3D brickTexture;

				Buffers::IndirectDrawBuffer levelBuffers[10];
			};
		}
	}
}

#endif