#ifndef _ENGINE_GRAPHIC_GI_PREPARATION_OCTREEPREPARATION_HPP
#define _ENGINE_GRAPHIC_GI_PREPARATION_OCTREEPREPARATION_HPP

#include "IPreparationStage.hpp"
#include "../../Buffers/Texture3D.hpp"
#include "../../Shaders/Shader.hpp"
#include "../../../Util/GLStopWatch.hpp"

namespace Engine
{
	namespace Graphic
	{
		namespace GI
		{
			namespace Preparation
			{
				class _DLL_DECLSPEC OctreePreparationStage : public IPreparationStage
				{
				public:
					OctreePreparationStage(Scene::Components::VoxelOctreeComponent* _component, EngineManager* _manager, GraphicContext* _context);
					virtual ~OctreePreparationStage();

					virtual void Process();

#ifdef _ENGINE_OCTREEE_TIMERS
					Util::GLStopWatch& TotalWatch();
					Util::GLStopWatch* MipmapWatches();
					Util::GLStopWatch* TransferWatches();
#endif

				private:
					void WriteToFile(const std::string _path) const;

					Shaders::Shader mipmapShader;
					Shaders::Shader transferShader;

					GLuint octreeVAO;

					GraphicContext* context;
					EngineManager* manager;
					Scene::Components::VoxelOctreeComponent* component;

					bool doTransfer;

#ifdef _ENGINE_OCTREEE_TIMERS
					Util::GLStopWatch totalWatch;
					Util::GLStopWatch mipmapWatches[8];
					Util::GLStopWatch transferWatches[8];
#endif
				};
			}
		}
	}
}

#endif