#ifndef _ENGINE_GRAPHIC_GI_RENDERING_OCTREEDEBUGRENDERSTAGE_HPP
#define _ENGINE_GRAPHIC_GI_RENDERING_OCTREEDEBUGRENDERSTAGE_HPP

#include "../../../dllconfig.hpp"
#include "../../../Prototypes.hpp"

#include "IRenderStage.hpp"
#include "../../Shaders/Shader.hpp"
#include "../../../Util/GLStopWatch.hpp"

#include <sstream>

namespace Engine
{
	namespace Graphic
	{
		namespace GI
		{
			namespace Rendering
			{
				class _DLL_DECLSPEC OctreeDebugRenderStage : public IRenderStage
				{
				public:
					OctreeDebugRenderStage(Scene::Components::VoxelOctreeComponent* _component, GraphicContext* _context, EngineManager* _manager);
					virtual ~OctreeDebugRenderStage();

					void Process(const Math::Mat4f& _cameraMatrix);

				private:
					Scene::Components::VoxelOctreeComponent* component;
					GraphicContext* context;
					unsigned int level;
					Shaders::Shader shader;
					EngineManager* manager;
					GLuint vao;

					bool showVoxels;

#ifdef _ENGINE_OCTREEE_TIMERS
					Util::GLStopWatch totalWatch;

					std::stringstream cameraTotal;
					std::stringstream renderTotal;
					std::stringstream generationTotal;
					std::stringstream generationInit;
					std::stringstream generationVoxelize;
					std::stringstream generationBuildOctree[10];
					std::stringstream totalTime;
					std::stringstream preparationTotal;
					std::stringstream preparationMipmap[9];
					std::stringstream preparationTransfer[9];
					std::stringstream illuminationTotal;
					unsigned int detailComponent;
#endif
				};
			}
		}
	}
}

#endif