#define DLL_EXPORT

#include "BlendingState.hpp"
#include "../GraphicContext.hpp"

using namespace Engine;
using namespace Engine::Graphic;
using namespace Engine::Graphic::DelayedChange;
using namespace Engine::Graphic::GraphicStates;

BlendingState::BlendingState(GraphicContext* _context) : IDelayedValue(_context), state(GL_FALSE), sFactor(GL_ONE), dFactor(GL_ZERO)
{ }
BlendingState::~BlendingState()
{ }

void BlendingState::Disable()
{
	if (state != GL_FALSE)
	{
		state = GL_FALSE;
		OnNotifyValueChanged();
	}
}

void BlendingState::Enable(GLenum _sFactor, GLenum _dFactor)
{
	if (state != GL_TRUE || sFactor != _sFactor || dFactor != _dFactor)
	{
		state = GL_TRUE;
		sFactor = _sFactor;
		dFactor = _dFactor;
		OnNotifyValueChanged();
	}
}

void BlendingState::DoChangeValue()
{
	if (state == GL_TRUE)
	{
		glEnable(GL_BLEND);
		glBlendFunc(sFactor, dFactor);
	}
	else
		glDisable(GL_BLEND);
}