#ifndef _ENGINE_GRAPHIC_GRAPHICSTATES_BLENDINGSTATE_HPP
#define _ENGINE_GRAPHIC_GRAPHICSTATES_BLENDINGSTATE_HPP

#include "../DelayedChange/IDelayedValue.hpp"
#include <gl\glew.h>

namespace Engine
{
	namespace Graphic
	{
		class GraphicContext;

		namespace GraphicStates
		{
			class _DLL_DECLSPEC BlendingState : public DelayedChange::IDelayedValue
			{
			public:
				BlendingState(GraphicContext* _context);
				~BlendingState();

				void Disable();
				void Enable(GLenum _sFactor, GLenum _dFactor);

			protected:
				virtual void DoChangeValue();

			private:
				GLboolean state;
				GLenum sFactor, dFactor;
			};
		}
	}
}

#endif