#define DLL_EXPORT

#include "DepthTestState.hpp"
#include "../GraphicContext.hpp"

using namespace Engine;
using namespace Engine::Graphic;
using namespace Engine::Graphic::DelayedChange;
using namespace Engine::Graphic::GraphicStates;

DepthTestState::DepthTestState(GraphicContext* _context) : IDelayedValue(_context), writeState(GL_FALSE), testState(GL_FALSE), func(GL_LESS)
{ }
DepthTestState::~DepthTestState()
{ }

void DepthTestState::TestAndWrite()
{
	if (testState != GL_TRUE || writeState != GL_TRUE) //Vorher nicht aktiviert
	{
		testState = GL_TRUE;
		writeState = GL_TRUE;
		OnNotifyValueChanged();
	}
}

void DepthTestState::TestOnly()
{
	if (testState != GL_TRUE || writeState != GL_FALSE)
	{
		testState = GL_TRUE;
		writeState = GL_FALSE;
		OnNotifyValueChanged();
	}
}

void DepthTestState::WriteOnly()
{
	if (testState != GL_FALSE || writeState != GL_TRUE)
	{
		testState = GL_FALSE;
		writeState = GL_TRUE;
		OnNotifyValueChanged();
	}
}

void DepthTestState::Disable()
{
	if (testState != GL_FALSE || writeState != GL_FALSE)
	{
		testState = GL_FALSE;
		writeState = GL_FALSE;
		OnNotifyValueChanged();
	}
}

void DepthTestState::DoChangeValue()
{
	if (testState == GL_FALSE && writeState == GL_FALSE) //Disable
		glDisable(GL_DEPTH_TEST);
	else
	{
		glEnable(GL_DEPTH_TEST);

		if (testState == GL_TRUE)
			glDepthFunc(func);
		else
			glDepthFunc(GL_ALWAYS);

		glDepthMask(writeState);
	}
}

void DepthTestState::DepthFunc(GLenum _func)
{
	if (func != _func)
	{
		func = _func;
		OnNotifyValueChanged();
	}
}