#ifndef _ENGINE_GRAPHIC_GRAPHICSTATES_DEPTHTESTSTATE_HPP
#define _ENGINE_GRAPHIC_GRAPHICSTATES_DEPTHTESTSTATE_HPP

#include "../DelayedChange/IDelayedValue.hpp"
#include <gl\glew.h>

namespace Engine
{
	namespace Graphic
	{
		class GraphicContext;

		namespace GraphicStates
		{
			class _DLL_DECLSPEC DepthTestState : public DelayedChange::IDelayedValue
			{
			public:
				DepthTestState(GraphicContext* _context);
				~DepthTestState();

				void TestAndWrite();
				void TestOnly();
				void WriteOnly();
				void Disable();
				void DepthFunc(GLenum _func);

			protected:
				virtual void DoChangeValue();

			private:
				GLenum func;
				GLboolean testState;
				GLboolean writeState;
			};
		}
	}
}

#endif