#define DLL_EXPORT

#include "FaceCullingState.hpp"
#include "../GraphicContext.hpp"

using namespace Engine;
using namespace Engine::Graphic;
using namespace Engine::Graphic::DelayedChange;
using namespace Engine::Graphic::GraphicStates;

FaceCullingState::FaceCullingState(GraphicContext* _context) : IDelayedValue(_context), state(GL_FALSE), mode(GL_BACK)
{ }
FaceCullingState::~FaceCullingState()
{ }

void FaceCullingState::Disable()
{
	if (state != GL_FALSE)
	{
		state = GL_FALSE;
		OnNotifyValueChanged();
	}
}

void FaceCullingState::EnableBackFaceCulling()
{
	if (state != GL_TRUE || mode != GL_BACK)
	{
		state = GL_TRUE;
		mode = GL_BACK;
		OnNotifyValueChanged();
	}
}
void FaceCullingState::EnableFrontFaceCulling()
{
	if (state != GL_TRUE || mode != GL_FRONT)
	{
		state = GL_TRUE;
		mode = GL_FRONT;
		OnNotifyValueChanged();
	}
}

void FaceCullingState::DoChangeValue()
{
	if (state == GL_TRUE)
	{
		glEnable(GL_CULL_FACE);
		glCullFace(mode);
	}
	else
		glDisable(GL_CULL_FACE);
}