#ifndef _ENGINE_GRAPHIC_GRAPHICSTATES_FACECULLINGSTATE_HPP
#define _ENGINE_GRAPHIC_GRAPHICSTATES_FACECULLINGSTATE_HPP

#include "../DelayedChange/IDelayedValue.hpp"
#include <gl\glew.h>

namespace Engine
{
	namespace Graphic
	{
		class GraphicContext;

		namespace GraphicStates
		{
			class _DLL_DECLSPEC FaceCullingState : public DelayedChange::IDelayedValue
			{
			public:
				FaceCullingState(GraphicContext* _context);
				~FaceCullingState();

				void Disable();
				void EnableBackFaceCulling();
				void EnableFrontFaceCulling();

			protected:
				virtual void DoChangeValue();

			private:
				GLboolean state;
				GLenum mode;
			};
		}
	}
}

#endif