#define DLL_EXPORT

#include "PolygonOffsetState.hpp"
#include "../GraphicContext.hpp"

using namespace Engine;
using namespace Engine::Graphic;
using namespace Engine::Graphic::DelayedChange;
using namespace Engine::Graphic::GraphicStates;

PolygonOffsetState::PolygonOffsetState(GraphicContext* _context) : IDelayedValue(_context), factor(0.0f), units(0.0f), state(GL_FALSE)
{ }
PolygonOffsetState::~PolygonOffsetState()
{ }

void PolygonOffsetState::Disable()
{
	if (state != GL_FALSE)
	{
		state = GL_FALSE;
		OnNotifyValueChanged();
	}
}

void PolygonOffsetState::Enable(GLfloat _factor, GLfloat _units)
{
	if (state != GL_TRUE || factor != _factor || units != _units)
	{
		state = GL_TRUE;
		factor = _factor;
		units = _units;
		OnNotifyValueChanged();
	}
}


void PolygonOffsetState::DoChangeValue()
{
	if (state == GL_TRUE)
	{
		glEnable(GL_POLYGON_OFFSET_FILL);
		glPolygonOffset(factor, units);
	}
	else
		glDisable(GL_POLYGON_OFFSET_FILL);
}