#define DLL_EXPORT

#include "RasterizerState.hpp"
#include "../GraphicContext.hpp"

using namespace Engine;
using namespace Engine::Graphic;
using namespace Engine::Graphic::DelayedChange;
using namespace Engine::Graphic::GraphicStates;

RasterizerState::RasterizerState(GraphicContext* _context) : IDelayedValue(_context), isEnabled(true)
{ }

RasterizerState::~RasterizerState()
{ }

void RasterizerState::Enable()
{
	if (!isEnabled)
	{
		isEnabled = true;
		OnNotifyValueChanged();
	}
}

void RasterizerState::Disable()
{
	if (isEnabled)
	{
		isEnabled = false;
		OnNotifyValueChanged();
	}
}

void RasterizerState::DoChangeValue()
{
	if (isEnabled)
		glDisable(GL_RASTERIZER_DISCARD);
	else
		glEnable(GL_RASTERIZER_DISCARD);
}