#ifndef _ENGINE_GRAPHIC_GRAPHICSTATES_STENCILTESTSTATE_HPP
#define _ENGINE_GRAPHIC_GRAPHICSTATES_STENCILTESTSTATE_HPP

#include "../DelayedChange/IDelayedValue.hpp"
#include <gl\glew.h>

namespace Engine
{
	namespace Graphic
	{
		class GraphicContext;

		namespace GraphicStates
		{
			class _DLL_DECLSPEC StencilTestState : public DelayedChange::IDelayedValue
			{
			public:
				StencilTestState(GraphicContext* _context);
				~StencilTestState();

				void Disable();
				void Enable();
				void Operation(GLenum _stencilFail, GLenum _depthFail, GLenum _pass);
				void Function(GLenum _func, GLint _refValue, GLuint _mask = 0xFFFFFFFF);

			protected:
				virtual void DoChangeValue();

			private:
				GLboolean state;
				GLenum stencilFail, depthFail, pass, func;
				GLint refValue;
				GLuint mask;
			};
		}
	}
}

#endif