#define DLL_EXPORT

#include "UnpackAlignmentState.hpp"
#include "../GraphicContext.hpp"

using namespace Engine;
using namespace Engine::Graphic;
using namespace Engine::Graphic::DelayedChange;
using namespace Engine::Graphic::GraphicStates;

UnpackAlignmentState::UnpackAlignmentState(GraphicContext* _context) : IDelayedValue(_context), alignment(4)
{ }
UnpackAlignmentState::~UnpackAlignmentState()
{ }

void UnpackAlignmentState::Set(GLint _alignment)
{
	if (alignment != _alignment)
	{
		//Hier muss immer gleich gewechselt werden, da das nicht nur auf Draw-Commands Auswirkung hat.
		alignment = _alignment;
		glPixelStorei(GL_UNPACK_ALIGNMENT, alignment);
	}
}

void UnpackAlignmentState::DoChangeValue()
{ }