#ifndef _ENGINE_GRAPHIC_ICONRENDERER_HPP
#define _ENGINE_GRAPHIC_ICONRENDERER_HPP

#include "../dllconfig.hpp"
#include "../Prototypes.hpp"
#include <gl\glew.h>

#include "Shaders\Shader.hpp"

namespace Engine
{
	namespace Graphic
	{
		class GraphicContext;

		class _DLL_DECLSPEC IconRenderer
		{
		public:
			IconRenderer(GraphicContext* _context, unsigned int _screenWidth, unsigned int _screenHeight);
			~IconRenderer();

			void Render(Buffers::Texture2D* _texture, const Math::Vec3f& _position, const Math::Mat4f& _cameraMatrix, const Math::Vec2f& _size);
			void Resize(unsigned int _widht, unsigned int _height);

		private:
			GraphicContext* context;

			Shaders::Shader iconShader;

			unsigned int width, height;
			GLuint vbo, vao;
		};
	}
}

#endif