#define DLL_EXPORT

#include "DiffuseColorMaterialPart.hpp"
#include "../Shaders/Shader.hpp"

using namespace Engine::Graphic::Materials;
using namespace Engine::Graphic::Shaders;
using namespace Engine::Math;

DiffuseColorMaterialPart::DiffuseColorMaterialPart(const Vec3f& _diffuseColor) : diffuseColor(_diffuseColor)
{ }

DiffuseColorMaterialPart::~DiffuseColorMaterialPart()
{ }

void DiffuseColorMaterialPart::ToShader(Shader* _shader)
{
	_shader->UniformVariable<Math::Vec3f>("diffuseColor") = diffuseColor;
}

MaterialPartType DiffuseColorMaterialPart::GetType() const
{
	return MaterialPartType::DiffuseColorMaterialPartType;
}

const Vec3f& DiffuseColorMaterialPart::DiffuseColor() const
{
	return diffuseColor;
}

void DiffuseColorMaterialPart::DiffuseColor(const Vec3f& _color)
{
	diffuseColor = _color;
}