#ifndef _ENGINE_GRAPHIC_MATERIALS_DIFFUSECOLORMATERIALPART_HPP
#define _ENGINE_GRAPHIC_MATERIALS_DIFFUSECOLORMATERIALPART_HPP

#include "IMaterialPart.hpp"
#include "../../Math/Math.hpp"

namespace Engine
{
	namespace Graphic
	{
		namespace Materials
		{
			class _DLL_DECLSPEC DiffuseColorMaterialPart : public IMaterialPart
			{
			public:
				DiffuseColorMaterialPart(const Math::Vec3f& _diffuseColor);
				virtual ~DiffuseColorMaterialPart();

				void ToShader(Shaders::Shader* _shader);

				MaterialPartType GetType() const;

				const Math::Vec3f& DiffuseColor() const;
				void DiffuseColor(const Math::Vec3f& _color);


			private:
				Math::Vec3f diffuseColor;
			};
		}
	}
}

#endif