#define DLL_EXPORT

#include "DiffuseTextureMaterialPart.hpp"
#include "../Shaders/Shader.hpp"

using namespace Engine;
using namespace Engine::Graphic;
using namespace Engine::Graphic::Materials;
using namespace Engine::Util;

DiffuseTextureMaterialPart::DiffuseTextureMaterialPart(TextureSharedPointer _texture) : texture(_texture)
{ }

DiffuseTextureMaterialPart::~DiffuseTextureMaterialPart()
{ }

void DiffuseTextureMaterialPart::ToShader(Shaders::Shader* _shader)
{
	GLint textureUnit = _shader->GetTextureUnit();
	texture->Bind(textureUnit);
	_shader->UniformVariable<GLint>("diffuseTexture") = textureUnit;
}

MaterialPartType DiffuseTextureMaterialPart::GetType() const
{
	return MaterialPartType::DiffuseTextureMaterialPartType;
}

void DiffuseTextureMaterialPart::Texture(TextureSharedPointer _texture)
{
	texture = _texture;
}