#ifndef _ENGINE_GRAPHIC_MATERIALS_DIFFUSETEXTUREMATERIALPART_HPP
#define _ENGINE_GRAPHIC_MATERIALS_DIFFUSETEXTUREMATERIALPART_HPP

#include "../../dllconfig.hpp"
#include "IMaterialPart.hpp"
#include "../Buffers/Texture2D.hpp"
#include "../../Util/SharedPointer.hpp"

namespace Engine
{
	namespace Graphic
	{
		namespace Materials
		{
			typedef Util::SharedPointer<Buffers::Texture2D> TextureSharedPointer;

			class _DLL_DECLSPEC DiffuseTextureMaterialPart : public IMaterialPart
			{
			public:
				DiffuseTextureMaterialPart(TextureSharedPointer _texture);
				~DiffuseTextureMaterialPart();

				void ToShader(Shaders::Shader* _shader);

				void Texture(TextureSharedPointer _texture);

				MaterialPartType GetType() const;

			private:
				TextureSharedPointer texture;
			};
		}
	}
}

#endif