#define DLL_EXPORT

#include "EmittingColorMaterialPart.hpp"
#include "../Shaders/Shader.hpp"

using namespace Engine::Graphic::Materials;
using namespace Engine::Graphic::Shaders;
using namespace Engine::Math;

EmittingColorMaterialPart::EmittingColorMaterialPart(const Vec3f& _emittingColor) : emittingColor(_emittingColor)
{ }

EmittingColorMaterialPart::~EmittingColorMaterialPart()
{ }

void EmittingColorMaterialPart::ToShader(Shader* _shader)
{
	_shader->UniformVariable<Math::Vec3f>("emittingColor") = emittingColor;
}

MaterialPartType EmittingColorMaterialPart::GetType() const
{
	return MaterialPartType::EmittingColorMaterialPartType;
}

const Vec3f& EmittingColorMaterialPart::EmittingColor() const
{
	return emittingColor;
}

void EmittingColorMaterialPart::EmittingColor(const Vec3f& _color)
{
	emittingColor = _color;
}