#define DLL_EXPORT

#include "NormalTextureMaterialPart.hpp"
#include "../Shaders/Shader.hpp"
#include "../Buffers/Texture2D.hpp"

using namespace Engine;
using namespace Engine::Graphic;
using namespace Engine::Graphic::Buffers;
using namespace Engine::Graphic::Materials;
using namespace Engine::Util;

NormalTextureMaterialPart::NormalTextureMaterialPart(Util::SharedPointer<Buffers::Texture2D> _texture) : texture(_texture)
{ }

NormalTextureMaterialPart::~NormalTextureMaterialPart()
{ }

void NormalTextureMaterialPart::ToShader(Shaders::Shader* _shader)
{
	GLint textureUnit = _shader->GetTextureUnit();
	texture->Bind(textureUnit);
	_shader->UniformVariable<GLint>("normalTexture") = textureUnit;
}

MaterialPartType NormalTextureMaterialPart::GetType() const
{
	return MaterialPartType::NormalTextureMaterialPartType;
}

void NormalTextureMaterialPart::Texture(Util::SharedPointer<Buffers::Texture2D> _texture)
{
	texture = _texture;
}