#ifndef _ENGINE_GRAPHIC_MATERIALS_NORMALTEXTUREMATERIALPART_HPP
#define _ENGINE_GRAPHIC_MATERIALS_NORMALTEXTUREMATERIALPART_HPP

#include "../../dllconfig.hpp"
#include "IMaterialPart.hpp"
#include "../Buffers/Texture2D.hpp"
#include "../../Util/SharedPointer.hpp"

namespace Engine
{
	namespace Graphic
	{
		namespace Materials
		{
			class _DLL_DECLSPEC NormalTextureMaterialPart : public IMaterialPart
			{
			public:
				NormalTextureMaterialPart(Util::SharedPointer<Graphic::Buffers::Texture2D> _texture);
				~NormalTextureMaterialPart();

				void ToShader(Shaders::Shader* _shader);

				void Texture(Util::SharedPointer<Graphic::Buffers::Texture2D> _texture);

				MaterialPartType GetType() const;

			private:
				Util::SharedPointer<Graphic::Buffers::Texture2D> texture;
			};
		}
	}
}

#endif