#define DLL_EXPORT

#include "OpacityMaterialPart.hpp"
#include "../Shaders/Shader.hpp"

using namespace Engine;
using namespace Engine::Graphic;
using namespace Engine::Graphic::Materials;

OpacityMaterialPart::OpacityMaterialPart(float _opacity) : opacity(_opacity)
{ }

OpacityMaterialPart::~OpacityMaterialPart()
{ }

void OpacityMaterialPart::ToShader(Shaders::Shader* _shader)
{
	_shader->UniformVariable<GLfloat>("opacity") = opacity;
}

MaterialPartType OpacityMaterialPart::GetType() const
{
	return MaterialPartType::OpacityMaterialPartType;
}

inline float OpacityMaterialPart::Opacity() const
{
	return opacity;
}
inline void OpacityMaterialPart::Opacity(float _value)
{
	opacity = _value;
}