#define DLL_EXPORT

#include "SpecularColorMaterialPart.hpp"
#include "../Shaders/Shader.hpp"

using namespace Engine;
using namespace Engine::Math;
using namespace Engine::Graphic::Materials;
using namespace Engine::Graphic::Shaders;

SpecularColorMaterialPart::SpecularColorMaterialPart(const Vec3f& _specularColor, float _hardness) : specularColor(_specularColor), hardness(_hardness)
{ }

SpecularColorMaterialPart::~SpecularColorMaterialPart()
{ }

void SpecularColorMaterialPart::ToShader(Shader* _shader)
{
	_shader->UniformVariable<Math::Vec3f>("specularColor") = specularColor;
	_shader->UniformVariable<GLfloat>("specularHardness") = hardness;
}

MaterialPartType SpecularColorMaterialPart::GetType() const
{
	return MaterialPartType::SpecularColorMaterialPartType;
}

const Math::Vec3f& SpecularColorMaterialPart::SpecularColor() const
{
	return specularColor;
}

void SpecularColorMaterialPart::SpecularColor(const Math::Vec3f& _color)
{
	specularColor = _color;
}

const float SpecularColorMaterialPart::Hardness() const
{
	return hardness;
}

void SpecularColorMaterialPart::Hardness (float _hardness)
{
	hardness = _hardness;
}