#ifndef _ENGINE_GRAPHIC_MATERIALS_SPECULARCOLORMATERIALPART_HPP
#define _ENGINE_GRAPHIC_MATERIALS_SPECULARCOLORMATERIALPART_HPP

#include "../../dllconfig.hpp"
#include "IMaterialPart.hpp"
#include "../../Math/Math.hpp"

namespace Engine
{
	namespace Graphic
	{
		namespace Materials
		{
			class _DLL_DECLSPEC SpecularColorMaterialPart : public IMaterialPart
			{
			public:
				SpecularColorMaterialPart(const Math::Vec3f& _specularColor, float _hardness);
				~SpecularColorMaterialPart();

				void ToShader(Shaders::Shader* _shader);

				MaterialPartType GetType() const;

				const Math::Vec3f& SpecularColor() const;
				void SpecularColor(const Math::Vec3f& _color);

				const float Hardness() const;
				void Hardness (float _hardness);

			private:
				Math::Vec3f specularColor;
				float hardness;
			};
		}
	}
}

#endif