#define DLL_EXPORT

#include "BSPNode.hpp"

using namespace Engine;
using namespace Engine::Graphic;
using namespace Engine::Graphic::Meshes;

BSPNode::BSPNode(unsigned int _i1, unsigned int _i2, unsigned int _i3, const Math::Vec4f& _plane) : back(nullptr), front(nullptr), plane(_plane)
{
	indices[0] = _i1;
	indices[1] = _i2;
	indices[2] = _i3;
}

BSPNode::~BSPNode()
{
	if (back != nullptr)
		delete back;
	if (front != nullptr)
		delete front;
}

inline const BSPNode* BSPNode::Front() const
{
	return front;
}
inline void BSPNode::Front(BSPNode* _value)
{
	front = _value;
}
inline const BSPNode* BSPNode::Back() const
{
	return back;
}
inline void BSPNode::Back(BSPNode* _value)
{
	back = _value;
}
inline const Math::Vec4f& BSPNode::Plane() const
{
	return plane;
}
inline const unsigned int* BSPNode::Indices() const
{
	return indices;
}