#ifndef _ENGINE_GRAPHIC_MESHES_BSPNODE_HPP
#define _ENGINE_GRAPHIC_MESHES_BSPNODE_HPP

#include "../../dllconfig.hpp"
#include "../../Math/Math.hpp"

namespace Engine
{
	namespace Graphic
	{
		namespace Meshes
		{
			class _DLL_DECLSPEC BSPNode
			{
			public:
				BSPNode(unsigned int _i1, unsigned int _i2, unsigned int _i3, const Math::Vec4f& _plane);
				~BSPNode();

				const BSPNode* Front() const;
				void Front(BSPNode* _value);
				const BSPNode* Back() const;
				void Back(BSPNode* _value);

				const unsigned int* Indices() const;

				const Math::Vec4f& Plane() const;

			private:
				BSPNode *front, *back;
				unsigned int indices[3];
				Math::Vec4f plane;
			};
		}
	}
}

#endif