#ifndef _ENGINE_GRAPHIC_MESHES_MESH_HPP
#define _ENGINE_GRAPHIC_MESHES_MESH_HPP

#include "../../dllconfig.hpp"

#include "../GraphicContext.hpp"
#include "VertexStreamElement.hpp"
#include "../../Scene/Boundings/Box.hpp"
#include <gl\glew.h>
#include <vector>

namespace Engine
{
	namespace Graphic
	{
		namespace Meshes
		{
			class _DLL_DECLSPEC Mesh
			{
			public:
				Mesh(float* _vertexData, unsigned int _vertexCount, unsigned int _vertexSize, unsigned int* _indices, unsigned int _indexCount, const std::vector<VertexStreamElement>& _mapping,
					 const Math::Vec4f& _boundingLocation, const Math::Vec3f& _boundingSize, GraphicContext* _context);
				~Mesh();

				void Draw(GLenum _primitiveType);

				const Scene::Boundings::Box& BoundingBox() const;

			private:
				GLuint vbo, indexVbo, vao;
				GLsizei count;

				GraphicContext* context;
				Scene::Boundings::Box boundingBox;
			};
		}
	}
}

#endif