#define DLL_EXPORT

#include "VertexStreamElement.hpp"

using namespace Engine::Graphic::Meshes;

VertexStreamElement::VertexStreamElement(GLuint _attribHandle, GLint _size, GLuint _offset) : attribHandle(_attribHandle), size(_size), offset(_offset)
{ }

VertexStreamElement::VertexStreamElement(const VertexStreamElement& _element) : attribHandle(_element.attribHandle), size(_element.size), offset(_element.offset)
{ }

VertexStreamElement& VertexStreamElement::operator = (const VertexStreamElement& _element)
{
	attribHandle = _element.attribHandle;
	size = _element.size;
	offset = _element.offset;
	return *this;
}

GLuint VertexStreamElement::AttribHandle() const
{
	return attribHandle;
}

GLint VertexStreamElement::Size() const
{
	return size;
}

GLuint VertexStreamElement::Offset() const
{
	return offset;
}