#ifndef _ENGINE_MATH
#define _ENGINE_MATH

#include "../dllconfig.hpp"

#ifdef USE_SSE_MATH
#include "SSE\SSE.hpp"
#else
#include "CPPonly\CPPonly.hpp"
#endif


namespace Engine
{
	namespace Math
	{
#ifdef USE_SSE_MATH
		typedef SSE::Vec2f Vec2f;
		typedef SSE::Vec3f Vec3f;
		typedef SSE::Vec4f Vec4f;
		typedef SSE::Mat3f Mat3f;
		typedef SSE::Mat4f Mat4f;
#else
		typedef CPPonly::Vec2f Vec2f;
		typedef CPPonly::Vec3f Vec3f;
		typedef CPPonly::Vec4f Vec4f;
		typedef CPPonly::Mat3f Mat3f;
		typedef CPPonly::Mat4f Mat4f;
#endif
	}
}

#endif