/*
 * BlubbEngine2 - Tools: IncludeFileGenerator
 * Wed Oct 16 12:43:41 CEST 2013
 *
 * This file is automatically generated, do not edit.
 */

#ifndef _PROTOTYPES_HPP
#define _PROTOTYPES_HPP

namespace std
{
}
namespace Engine
{
	class EngineManager;

	namespace Util
	{
		class Convert;
		class StopWatch;
		class Clock;
		class Logger;
		class GLStopWatch;

		namespace Debugging
		{
			class StackFrame;
			class InternalDebugger;
		}
	}
	namespace Graphic
	{
		class IconRenderer;
		class GraphicContext;
		class FontRenderer;

		namespace DelayedChange
		{
			class IDelayedValue;
			class IDelayedValueObserver;
		}
		namespace Meshes
		{
			class Mesh;
			class TransparentMesh;
			class BSPNode;
			class BSPTriangle;
			class VertexStreamElement;
		}
		namespace BasicBodies
		{
			class Plane;
			class Cone;
			class LineCube;
			class LineCone;
			class LineSphere;
			class IcoSphere;
		}
		namespace Materials
		{
			class SpecularColorMaterialPart;
			class IMaterialPart;
			class NormalTextureMaterialPart;
			class DiffuseColorMaterialPart;
			class Material;
			class DiffuseTextureMaterialPart;
			class OpacityMaterialPart;
			class EmittingColorMaterialPart;
		}
		namespace Buffers
		{
			class ShaderStorageBuffer;
			class Texture2D;
			class Texture3D;
			class AtomicCounterBuffer;
			class TextureBuffer;
			class IndirectDrawBuffer;
			class Buffer;
		}
		namespace GraphicStates
		{
			class FaceCullingState;
			class PolygonOffsetState;
			class DepthTestState;
			class StencilTestState;
			class UnpackAlignmentState;
			class BlendingState;
			class LineWidthState;
			class RasterizerState;
		}
		namespace FrameBuffers
		{
			class FrameBuffer;
		}
		namespace GI
		{
			class OctreeData;
			class GIData;

			namespace Rendering
			{
				class OctreeDebugRenderStage;
				class IRenderStage;
			}
			namespace Illumination
			{
				class IIlluminationStage;
				class DirectIlluminationStage;
				class IndirectIlluminationStage;
				class AmbientOcclusionIlluminationStage;
			}
			namespace Preparation
			{
				class IPreparationStage;
				class OctreePreparationStage;
			}
			namespace Generation
			{
				class IGenerationStage;
				class OctreeGenerationStage;
			}
		}
		namespace Effects
		{
			class TonemapEffect;
			class GaussEffect;
			class FxaaEffect;
			class PointLightEffect;
			class DirectionalLightEffect;
			class SpotLightEffect;
		}
		namespace Shaders
		{
			class IUniformArray;
			class IUniform;
			class Shader;
		}
	}
	namespace Core
	{
		namespace Memory
		{
			class DoubleStackAllocator;
			class StackAllocator;
			class HeapAllocator;
			class Allocator;
			class PoolAllocator;
		}
		namespace Collections
		{
			class HashString;
			class ConstCharWrapper;
		}
		namespace IO
		{
			class PngLoader;
			class DictionaryEntry;
			class SystemConfigurationReader;
			class KeyboardInput;
			class AssetLoader;
			class MemoryReader;
			class MouseInput;
		}
		namespace Hardware
		{
			class Initializer;
			class CPUInformation;
		}
		namespace EventHandling
		{
			class IEventHandler;
			class EventArgs;
		}
		namespace System
		{
			class SystemConfiguration;
			class Initializer;
			class WorkerThread;

			namespace Tasks
			{
				class UpdateTask;
				class CullingTask;
				class PositionUpdateTask;
			}
		}
		namespace Concurrency
		{
			class BlockLocker;
			class ThreadManager;
			class Event;
			class Lockable;
			class Thread;
		}
		namespace Control
		{
			class Window;
			class SystemConsole;
			class RenderControl;
		}
	}
	namespace Scene
	{
		class ParentChangedEventArgs;
		class SceneObject;
		class World;

		namespace Cameras
		{
			class RenderCamera;
			class Camera;
			class GICamera;
		}
		namespace Components
		{
			class RenderComponent;
			class IComponent;
			class TransparentMeshRenderComponent;
			class CameraComponent;
			class VoxelOctreeComponent;
			class AnimationComponent;
			class ComponentChangedEventArgs;
			class PositionComponent;
			class MeshRenderComponent;
			class BoundingComponent;

			namespace ControllerComponents
			{
				class OrbitControllerComponent;
				class FreeFlyControllerComponent;
			}
			namespace LightComponents
			{
				class SpotLightComponent;
				class PointLightComponent;
				class DirectionalLightComponent;
				class LightComponent;
			}
		}
		namespace Animations
		{
			class CurvePoint;
			class Curve;
			class Animation;
			class CurveData;
		}
		namespace Boundings
		{
			class Cone;
			class TransformedBox;
			class BoxBspNode;
			class BoundingObject;
			class Box;
			class Sphere;
			class Frustum;

			namespace Bih
			{
			}
		}
		namespace Lights
		{
			class SpotLight;
			class Light;
			class PointLight;
			class DirectionalLight;
		}
	}
	namespace Math
	{
		namespace CPPonly
		{
			class Mat4f;
			class Mat3f;
			class Vec3f;
			class Vec4f;
			class Vec2f;
		}
		namespace SSE
		{
			class Mat4f;
			class Mat3f;
			class Vec3f;
			class Vec4f;
			class Vec2f;
		}
	}
}

#endif