#ifndef _ENGINE_SCENE_ANIMATIONS_ANIMATION_HPP
#define _ENGINE_SCENE_ANIMATIONS_ANIMATION_HPP

#include "../../dllconfig.hpp"
#include "../../Prototypes.hpp"

#include <string>

namespace Engine
{
	namespace Scene
	{
		namespace Animations
		{
			class _DLL_DECLSPEC Animation
			{
			public:
				Animation(std::string _name, Curve** _curves, unsigned int _count, bool _isLooped, float _speed = 1.0f);
				~Animation();

				void BindComponent(float* _locX, float* _locY, float* _locZ, float* _rotX, float* _rotY, float* _rotZ, float* _scaleX, float* _scaleY, float* _scaleZ);

				void Update(float _t);

				void Start();
				void Stop();
				void Resume();

				float Speed() const;
				void Speed(float _value);

				std::string Name() const;
				
			private:
				std::string name;
				float startTime, lastUpdateTime;
				float speed;
				Curve** curves;
				unsigned int count;
				bool isLooped, running;
				float maximalLength;
			};
		}
	}
}

#endif