#ifndef _ENGINE_SCENE_ANIMATIONS_CURVE_HPP
#define _ENGINE_SCENE_ANIMATIONS_CURVE_HPP

#include "../../dllconfig.hpp"
#include "../../Prototypes.hpp"
#include "../../Core/Collections/UnorderedMapExtensions.hpp"

#include "../../Util/SharedPointer.hpp"

namespace Engine
{
	namespace Scene
	{
		namespace Animations
		{
			class _DLL_DECLSPEC Curve
			{
			public:
				Curve(Util::SharedPointer<CurveData> _data);
				~Curve();

				void Interpolate(float _t);
				float Length() const;

				void TargetValue(float* _value);
				const Util::SharedPointer<CurveData>& Data() const;


			private:
				static void Berekeny(float _y1, float _y2, float _y3, float _y4, float* _o, int _b);
				static int FindZero(float _x, float _x0, float _x1, float _x2, float _x3, float *_o);
				static double Sqrt3d(double _d);

				Util::SharedPointer<CurveData> data;
				unsigned int lastPointIdx;
				float* targetValue;
				float length;
			};
		}
	}
}

#endif