#ifndef _ENGINE_SCENE_ANIMATIONS_CURVEDATA_HPP
#define _ENGINE_SCENE_ANIMATIONS_CURVEDATA_HPP

#include "../../dllconfig.hpp"
#include "../../Prototypes.hpp"

namespace Engine
{
	namespace Scene
	{
		namespace Animations
		{
			enum CurveTarget : unsigned char
			{
				LocationXCurveTarget = 0,
				LocationYCurveTarget = 1,
				LocationZCurveTarget = 2,

				RotationXCurveTarget = 3,
				RotationYCurveTarget = 4,
				RotationZCurveTarget = 5,

				ScaleXCurveTarget = 6,
				ScaleYCurveTarget = 7,
				ScaleZCurveTarget = 8,
			};

			class _DLL_DECLSPEC CurveData
			{
			public:
				CurveData(CurvePoint* _points, unsigned int _count, CurveTarget _target);
				~CurveData();

				CurvePoint* Points() const;
				unsigned int Count() const;
				CurveTarget Target() const;

			private:
				CurvePoint* points;
				unsigned int count;
				CurveTarget target;
			};
		}
	}
}

#endif