#define DLL_EXPORT

#include "CurvePoint.hpp"

using namespace Engine;
using namespace Engine::Scene;
using namespace Engine::Scene::Animations;

CurvePoint::CurvePoint() : point(), prevHandle(), nextHandle(), mode(InterpolationMode::LinearInterpolationMode)
{ }

CurvePoint::CurvePoint(const Math::Vec2f& _point, const Math::Vec2f& _prevHandle, const Math::Vec2f& _nextHandle, InterpolationMode _interpolation)
	: point(_point), prevHandle(_prevHandle), nextHandle(_nextHandle), mode(_interpolation)
{ }

CurvePoint::CurvePoint(const CurvePoint& _point) : point(_point.point), prevHandle(_point.prevHandle), nextHandle(_point.nextHandle), mode(_point.mode)
{ }

inline const Math::Vec2f& CurvePoint::Point() const
{
	return point;
}
inline const Math::Vec2f& CurvePoint::NextHandle() const
{
	return nextHandle;
}
inline const Math::Vec2f& CurvePoint::PrevHandle() const
{
	return prevHandle;
}
inline InterpolationMode CurvePoint::Interpolation() const
{
	return mode;
}