#ifndef _ENGINE_SCENE_ANIMATIONS_CURVEPOINT_HPP
#define _ENGINE_SCENE_ANIMATIONS_CURVEPOINT_HPP

#include "../../dllconfig.hpp"
#include "../../Prototypes.hpp"

#include "../../Math/Math.hpp"

namespace Engine
{
	namespace Scene
	{
		namespace Animations
		{
			enum InterpolationMode : unsigned char
			{
				LinearInterpolationMode = 1,
				BezierInterpolationMode = 2
			};

			class _DLL_DECLSPEC CurvePoint
			{
			public:
				CurvePoint();
				CurvePoint(const Math::Vec2f& _point, const Math::Vec2f& _prevHandle, const Math::Vec2f& _nextHandle, InterpolationMode _interpolation);
				CurvePoint(const CurvePoint& _point);

				const Math::Vec2f& Point() const;
				const Math::Vec2f& NextHandle() const;
				const Math::Vec2f& PrevHandle() const;
				InterpolationMode Interpolation() const;

			private:
				Math::Vec2f point, prevHandle, nextHandle;
				InterpolationMode mode;
			};
		}
	}
}

#endif