#ifndef _ENGINE_SCENE_BOUNDINGS_BOUNDINGOBJECT_HPP
#define _ENGINE_SCENE_BOUNDINGS_BOUNDINGOBJECT_HPP

#include "../../dllconfig.hpp"
#include "../../Math/Math.hpp"
#include "SplittingResult.hpp"
#include "Bih/Bih.hpp"

namespace Engine
{
	namespace Scene
	{
		namespace Cameras
		{
			class Camera;
		}

		namespace Boundings
		{
			class _DLL_DECLSPEC BoundingObject
			{
			public:
				virtual ~BoundingObject();

				virtual BoundingObject* Transform(const Math::Mat4f& _matrix, BoundingObject* _target = nullptr) = 0;

				virtual SplittingResult IntersectPlane(const Math::Vec4f& _plane) const = 0;

				virtual bool IsVisible(const Cameras::Camera* const _camera) const = 0;

				virtual Math::Vec3f GetCenterPoint() const = 0;

				virtual Bih::MinMaxBoxf GetAabb() const = 0;
			};
		}
	}
}

#endif