#ifndef _ENGINE_SCENE_BOUNDINGS_BOX_HPP
#define _ENGINE_SCENE_BOUNDINGS_BOX_HPP

#include "../../dllconfig.hpp"
#include "../../Math/Math.hpp"
#include "TransformedBox.hpp"
#include "BoundingObject.hpp"

namespace Engine
{
	namespace Scene
	{
		namespace Boundings
		{
			class _DLL_DECLSPEC Box : public BoundingObject
			{
			public:
				Box(const Math::Vec4f& _location, const Math::Vec3f& _size);

				BoundingObject* Transform(const Math::Mat4f& _matrix, BoundingObject* _target = nullptr);

				const Math::Vec3f& Size() const;
				const Math::Vec4f& Location() const;

				bool IsVisible(const Cameras::Camera* const _camera) const;

				SplittingResult IntersectPlane(const Math::Vec4f& _plane) const;

				Math::Vec3f GetCenterPoint() const;

				Bih::MinMaxBoxf GetAabb() const;

			private:
				Math::Vec4f location;
				Math::Vec3f size;
			};
		}
	}
}

#endif