#ifndef _ENGINE_SCENE_BOUNDINGS_BOXBSPNODE_HPP
#define _ENGINE_SCENE_BOUNDINGS_BOXBSPNODE_HPP

#include "../../dllconfig.hpp"
#include "../../Math/Math.hpp"

namespace Engine
{
	namespace Scene
	{
		namespace Components
		{
			class TransparentMeshRenderComponent;
		}

		namespace Boundings
		{
			class _DLL_DECLSPEC BoxBspNode
			{
			public:
				BoxBspNode(int _index, const Math::Vec4f& _plane);
				BoxBspNode(const BoxBspNode& _node);
				~BoxBspNode();

				BoxBspNode& operator = (const BoxBspNode& _node);

				const int Index() const;
				const Math::Vec4f& Plane() const;

				const int Front() const;
				void Front(int _node);
				const int Back() const;
				void Back(int _node);

			private:
				int index;
				Math::Vec4f plane;
				int front, back;
			};
		}
	}
}

#endif
