#define DLL_EXPORT

#include "BoxBSPNode.hpp"
#include "../../Scene/Components/TransparentMeshRenderComponent.hpp"

using namespace Engine;
using namespace Engine::Math;
using namespace Engine::Scene;
using namespace Engine::Scene::Boundings;
using namespace Engine::Scene::Components;

BoxBspNode::BoxBspNode(int _index, const Math::Vec4f& _plane) : index(_index), plane(_plane), front(-1), back(-1)
{ }

BoxBspNode::BoxBspNode(const BoxBspNode& _node) : index(_node.index), plane(_node.plane), front(_node.front), back(_node.back)
{ }

BoxBspNode::~BoxBspNode()
{ }

BoxBspNode& BoxBspNode::operator = (const BoxBspNode& _node)
{
	index = _node.index;
	plane = _node.plane;
	front = _node.front;
	back = _node.back;

	return *this;
}

inline const int BoxBspNode::Index() const
{
	return index;
}
inline const Math::Vec4f& BoxBspNode::Plane() const
{
	return plane;
}

inline const int BoxBspNode::Front() const
{
	return front;
}
inline void BoxBspNode::Front(int _node)
{
	front = _node;
}
inline const int BoxBspNode::Back() const
{
	return back;
}
inline void BoxBspNode::Back(int _node)
{
	back = _node;
}