#ifndef _ENGINE_SCENE_BOUNDINGS_SPHERE_HPP
#define _ENGINE_SCENE_BOUNDINGS_SPHERE_HPP

#include "BoundingObject.hpp"
#include "../../Math/Math.hpp"

namespace Engine
{
	namespace Scene
	{
		namespace Boundings
		{
			class _DLL_DECLSPEC Sphere : public BoundingObject
			{
			public:
				Sphere(const Math::Vec4f& _center, float _radius);
				~Sphere();

				float Radius() const;
				const Math::Vec4f& Center() const;

				BoundingObject* Transform(const Math::Mat4f& _matrix, BoundingObject* _target = nullptr);
				bool IsVisible(const Cameras::Camera* const _camera) const;

				SplittingResult IntersectPlane(const Math::Vec4f& _plane) const;

				Math::Vec3f GetCenterPoint() const;

				Bih::MinMaxBoxf GetAabb() const;

			private:
				float radius;
				Math::Vec4f center;
			};
		}
	}
}

#endif