#define DLL_EXPORT

#include "Camera.hpp"
#include "../SceneObject.hpp"
#include "../World.hpp"
#include "../SceneObject.hpp"
#include "../../EngineManager.hpp"

using namespace Engine;
using namespace Engine::Math;
using namespace Engine::Scene::Boundings;
using namespace Engine::Scene;
using namespace Engine::Scene::Components;
using namespace Engine::Scene::Cameras;


Camera::Camera(Scene::SceneObject* _sceneObject, EngineManager* _manager) : sceneObject(_sceneObject), manager(_manager)
{
}

Camera::~Camera()
{ }

void Camera::ResetVisibility()
{
	visibility.assign(sceneObject->World()->BoundingObjects().size(), (char)false);
}

std::vector<char>& Camera::Visibility()
{
	return visibility;
}

Scene::SceneObject* Camera::SceneObject() const
{
	return sceneObject;
}

void Camera::Visibility(int _index, bool _value)
{
	visibility[_index] = (bool)_value;
}

inline EngineManager* Camera::Manager() const
{
	return manager;
}