#ifndef _ENGINE_SCENE_COMPONENTS_ANIMATIONCOMPONENT_HPP
#define _ENGINE_SCENE_COMPONENTS_ANIMATIONCOMPONENT_HPP

#include "../../Prototypes.hpp"
#include "IComponent.hpp"

#include "../../Math/Math.hpp"
#include "../../Core/Collections/HashString.hpp"
#include <unordered_map>

namespace Engine
{
	namespace Scene
	{
		namespace Components
		{
			class _DLL_DECLSPEC AnimationComponent : public IComponent
			{
			public:
				AnimationComponent(Scene::SceneObject* _sceneObject, EngineManager* _manager, const Math::Vec3f& _translate, const Math::Vec3f& _rotate, const Math::Vec3f& _scale);
				~AnimationComponent();
				
				void RegisterAnimation(Core::Collections::HashString _name, Animations::Animation* _animation);

				ComponentType GetComponentType();
				static ComponentType ComponentTypeOf(); //Muss immer implementiert werden

				const std::unordered_map<Core::Collections::HashString, Animations::Animation*>& AnimationList() const;

			protected:
				void UpdateComponent();

			private:
				EngineManager* manager;
				Math::Vec3f loc, rot, scale;
				std::unordered_map<Core::Collections::HashString, Animations::Animation*> animations;
			};
		}
	}
}

#endif