#ifndef _ENGINE_SCENE_COMPONENTS_BOUNDINGCOMPONENT_HPP
#define _ENGINE_SCENE_COMPONENTS_BOUNDINGCOMPONENT_HPP

#include "../../Prototypes.hpp"

#include "IComponent.hpp"

namespace Engine
{
	namespace Scene
	{
		namespace Components
		{
			class _DLL_DECLSPEC BoundingComponent : public IComponent
			{
			public:
				BoundingComponent(Scene::SceneObject* _sceneObject, Boundings::BoundingObject* _boundingObject);
				~BoundingComponent();

				ComponentType GetComponentType();
				static ComponentType ComponentTypeOf(); //Muss immer implementiert werden

				Boundings::BoundingObject* Object() const;
				Boundings::BoundingObject* WorldObject() const;

				const size_t VisibilityIndex() const;
				void VisibilityIndex(size_t _index);

				bool IsVisible() const;
				void AddVisible();

			protected:
				void UpdateComponent();

			private:
				size_t visibilityIndex;
				bool isSomewhereVisible;
				Boundings::BoundingObject* boundingObject, *worldBoundingObject;
			};
		}
	}
}

#endif