#define DLL_EXPORT

#include "CameraComponent.hpp"
#include "../SceneObject.hpp"
#include "../World.hpp"
#include "PositionComponent.hpp"
#include "../Cameras/Camera.hpp"

using namespace Engine;
using namespace Engine::Scene;
using namespace Engine::Scene::Components;
using namespace Engine::Scene::Cameras;


CameraComponent::CameraComponent(Scene::SceneObject* _sceneObject, Cameras::Camera* _camera) : IComponent(_sceneObject, false), camera(_camera)
{
	_sceneObject->World()->RegisterCamera(this);
}

CameraComponent::~CameraComponent()
{
	delete camera;
}

ComponentType CameraComponent::GetComponentType()
{
	return ComponentType::CameraComponentType;
}

ComponentType CameraComponent::ComponentTypeOf()
{
	return ComponentType::CameraComponentType;
}

void CameraComponent::UpdateComponent()
{
	camera->ResetVisibility();
	camera->Update(SceneObject()->GetComponent<PositionComponent>()->WorldMatrix());
}

Cameras::Camera* CameraComponent::Camera() const
{
	return camera;
}

void CameraComponent::Render() const
{
	camera->Render();
}