#ifndef _ENGINE_SCENE_COMPONENTS_CAMERACOMPONENT_HPP
#define _ENGINE_SCENE_COMPONENTS_CAMERACOMPONENT_HPP

#include "../../dllconfig.hpp"
#include "../../Prototypes.hpp"

#include "IComponent.hpp"

namespace Engine
{
	namespace Scene
	{
		namespace Components
		{
			class _DLL_DECLSPEC CameraComponent : public IComponent
			{
			public:
				CameraComponent(Scene::SceneObject* _sceneObject, Engine::Scene::Cameras::Camera* _camera);
				~CameraComponent();

				virtual ComponentType GetComponentType();
				static ComponentType ComponentTypeOf(); //Muss immer implementiert werden
				
				Engine::Scene::Cameras::Camera* Camera() const;

				void Render() const;

			protected:
				virtual void UpdateComponent();

			private:
				EngineManager* manager;
				Cameras::Camera* camera;
			};
		}
	}
}

#endif