#ifndef _ENGINE_SCENE_COMPONENTS_COMPONENTCHANGEDEVENTARGS_HPP
#define _ENGINE_SCENE_COMPONENTS_COMPONENTCHANGEDEVENTARGS_HPP

#include "../../dllconfig.hpp"
#include "../../Prototypes.hpp"

#include "../../Core/EventHandling/EventArgs.hpp"


namespace Engine
{
	namespace Scene
	{
		namespace Components
		{
			enum ComponentActionType : bool
			{
				REMOVE = false,
				ADD = true
			};

			class _DLL_DECLSPEC ComponentChangedEventArgs : public Engine::Core::EventHandling::EventArgs
			{
			public:
				ComponentChangedEventArgs(IComponent* _component, ComponentActionType _actionType);
				
				IComponent* Component() const;
				ComponentActionType ActionType() const;

			private:
				IComponent* component;
				ComponentActionType actionType;
			};
		}
	}
}

#endif