#ifndef _ENGINE_SCENE_COMPONENTTYPE_HPP
#define _ENGINE_SCENE_COMPONENTTYPE_HPP

namespace Engine
{
	namespace Scene
	{
		namespace Components
		{
			enum ComponentType : unsigned short
			{
				PositionComponentType = 0,
				BoundingComponentType = 1,
				CameraComponentType = 2,
				FreeFlyControllerComponentType = 3,
				OrbitControllerComponentType = 4,
				AnimationComponentType = 5,
				VoxelOctreeComponentType = 6,

				UpdateAfterVisibility = 7, //Do not use this as a type
				BeginLightComponents = 7,  //Do not use this as a type

				DirectionalLightComponentType = 8,
				PointLightComponentType = 9,
				SpotLightComponentType = 10,

				EndLightComponents = 11,  //Do not use this as a type
				BeginRenderComponents = 11, //Do not use this as a type

				MeshRenderComponentType = 12,

				EndRenderComponents = 13,  //Do not use this as a type
				BeginForwardRenderComponents = 13, //Do not use this as a type
				
				TransparentMeshRenderComponentType = 14
			};
		}
	}
}


#endif