#ifndef _ENGINE_SCENE_COMPONENTS_CONTROLLERCOMPONENTS_FREEFLYCONTROLLERCOMPONENT_HPP
#define _ENGINE_SCENE_COMPONENTS_CONTROLLERCOMPONENTS_FREEFLYCONTROLLERCOMPONENT_HPP

#include "../IComponent.hpp"
#include "../../../Math/Math.hpp"

namespace Engine
{
	class EngineManager;

	namespace Scene
	{
		namespace Components
		{
			namespace ControllerComponents
			{
				class _DLL_DECLSPEC FreeFlyControllerComponent : public IComponent
				{
				public:
					FreeFlyControllerComponent(Scene::SceneObject* _sceneObject, EngineManager* _manager);
					~FreeFlyControllerComponent();

					virtual ComponentType GetComponentType();
					static ComponentType ComponentTypeOf(); //Muss immer implementiert werden

					float MoveSpeed() const;
					void MoveSpeed(float _speed);
					float MouseSpeed() const;
					void MouseSpeed(float _speed);

				protected:
					virtual void OnEnabling();
					virtual void UpdateComponent();

				private:
					Math::Vec3f position;
					Math::Vec2f rotation;

					float moveSpeed, mouseSpeed;
					EngineManager* manager;
				};
			}
		}
	}
}

#endif