#ifndef _ENGINE_SCENE_COMPONENTS_CONTROLLERCOMPONENTS_ORBITCONTROLLERCOMPONENT_HPP
#define _ENGINE_SCENE_COMPONENTS_CONTROLLERCOMPONENTS_ORBITCONTROLLERCOMPONENT_HPP

#include "../IComponent.hpp"
#include "../../../Math/Math.hpp"

namespace Engine
{
	class EngineManager;

	namespace Scene
	{
		namespace Components
		{
			namespace ControllerComponents
			{
				class _DLL_DECLSPEC OrbitControllerComponent : public IComponent
				{
				public:
					OrbitControllerComponent(Scene::SceneObject* _sceneObject, EngineManager* _manager);
					~OrbitControllerComponent();

					virtual ComponentType GetComponentType();
					static ComponentType ComponentTypeOf(); //Muss immer implementiert werden

					float MoveSpeed() const;
					void MoveSpeed(float _speed);
					float MouseSpeed() const;
					void MouseSpeed(float _speed);
					float MouseWheelSpeed() const;
					void MouseWheelSpeed(float _speed);

				protected:
					virtual void UpdateComponent();
					virtual void OnEnabling();

				private:
					Math::Vec3f position;
					Math::Mat4f rotation;
					float distance;

					float moveSpeed, mouseSpeed, mouseWheelSpeed;
					EngineManager* manager;
				};
			}
		}
	}
}

#endif