#ifndef _ENGINE_SCENE_COMPONENTS_ICOMPONENT_HPP
#define _ENGINE_SCENE_COMPONENTS_ICOMPONENT_HPP

#include "../../dllconfig.hpp"
#include "ComponentType.hpp"

namespace Engine
{
	namespace Scene
	{
		class SceneObject;

		namespace Components
		{
			class ENGINE_INTERFACE _DLL_DECLSPEC IComponent
			{
			public:
				IComponent(SceneObject* _sceneObject);
				IComponent(SceneObject* _sceneObject, const bool _registerUpdate);
				virtual ~IComponent();

				SceneObject* SceneObject();

				virtual Components::ComponentType GetComponentType() = 0;
				static Components::ComponentType ComponentTypeOf(); //Muss immer implementiert werden
				void Update();

				bool IsEnabled() const;
				void IsEnabled(bool _value);

			protected:
				virtual void OnEnabling();
				virtual void UpdateComponent() = 0;

			private:
				bool isEnabled;
				Engine::Scene::SceneObject* sceneObject;
			};
		}
	}
}

#endif