#define DLL_EXPORT

#include "DirectionalLightComponent.hpp"

#include "../PositionComponent.hpp"
#include "../../Lights/DirectionalLight.hpp"
#include "../../SceneObject.hpp"

using namespace Engine;
using namespace Engine::Scene;
using namespace Engine::Scene::Lights;
using namespace Engine::Scene::Components;
using namespace Engine::Scene::Components::LightComponents;

DirectionalLightComponent::DirectionalLightComponent(Scene::SceneObject* _sceneObject, Lights::DirectionalLight* _light) : LightComponent(_sceneObject), light(_light)
{ }

DirectionalLightComponent::~DirectionalLightComponent()
{
	delete light;
}

BoundingComponent* DirectionalLightComponent::Bounding() const
{
	return nullptr;
}

inline Lights::Light* DirectionalLightComponent::Light() const
{
	return light;
}

ComponentType DirectionalLightComponent::GetComponentType()
{
	return ComponentType::DirectionalLightComponentType;
}

ComponentType DirectionalLightComponent::ComponentTypeOf()
{
	return ComponentType::DirectionalLightComponentType;
}

void DirectionalLightComponent::UpdateComponent()
{
	PositionComponent* pc = SceneObject()->GetComponent<PositionComponent>();
	light->Update(pc->WorldMatrix());
}

void DirectionalLightComponent::RenderDebug(const Math::Mat4f& _cameraMatrix) const
{ }