#ifndef _ENGINE_SCENE_COMPONENTS_LIGHTCOMPONENTS_DIRECTIONALLIGHTCOMPONENT_HPP
#define _ENGINE_SCENE_COMPONENTS_LIGHTCOMPONENTS_DIRECTIONALLIGHTCOMPONENT_HPP

#include "../../../Prototypes.hpp"
#include "LightComponent.hpp"

namespace Engine
{
	namespace Scene
	{
		namespace Components
		{
			namespace LightComponents
			{
				class _DLL_DECLSPEC DirectionalLightComponent : public LightComponent
				{
				public:
					DirectionalLightComponent(Scene::SceneObject* _sceneObject, Lights::DirectionalLight* _light);
					~DirectionalLightComponent();

					virtual ComponentType GetComponentType();
					static ComponentType ComponentTypeOf(); //Muss immer implementiert werden

					virtual Lights::Light* Light() const;

					virtual void RenderDebug(const Math::Mat4f& _cameraMatrix) const;

					BoundingComponent* Bounding() const;

				protected:
					virtual void UpdateComponent();

				private:
					Lights::DirectionalLight* light;
				};
			}
		}
	}
}

#endif