#ifndef _ENGINE_SCENE_COMPONENTS_POINTLIGHTCOMPONENT_HPP
#define _ENGINE_SCENE_COMPONENTS_POINTLIGHTCOMPONENT_HPP

#include "../../../Prototypes.hpp"
#include "LightComponent.hpp"


namespace Engine
{
	namespace Graphic { class GraphicContext; }

	namespace Scene
	{
		namespace Components
		{
			namespace LightComponents
			{
				class _DLL_DECLSPEC PointLightComponent : public LightComponent
				{
				public:
					PointLightComponent(Scene::SceneObject* _sceneObject, Lights::PointLight* _light, Graphic::GraphicContext* _context);
					~PointLightComponent();

					virtual ComponentType GetComponentType();
					static ComponentType ComponentTypeOf(); //Muss immer implementiert werden

					virtual Lights::Light* Light() const;

					virtual void RenderDebug(const Math::Mat4f& _cameraMatrix) const;

					BoundingComponent* Bounding() const;

				protected:
					virtual void UpdateComponent();

				private:
					Lights::PointLight* light;
					BoundingComponent* bounding;

					Graphic::GraphicContext* context;
				};
			}
		}
	}
}

#endif