#ifndef _ENGINE_SCENE_COMPONENTS_LIGHTCOMPONENTS_SPOTLIGHTCOMPONENT_HPP
#define _ENGINE_SCENE_COMPONENTS_LIGHTCOMPONENTS_SPOTLIGHTCOMPONENT_HPP

#include "../../../Prototypes.hpp"
#include "LightComponent.hpp"

namespace Engine
{
	namespace Graphic { class GraphicContext; }

	namespace Scene
	{
		namespace Components
		{
			namespace LightComponents
			{
				class _DLL_DECLSPEC SpotLightComponent : public LightComponent
				{
				public:
					SpotLightComponent(Scene::SceneObject* _sceneObject, Lights::SpotLight* _light, Graphic::GraphicContext* _context);
					~SpotLightComponent();

					virtual ComponentType GetComponentType();
					static ComponentType ComponentTypeOf(); //Muss immer implementiert werden

					virtual Lights::Light* Light() const;

					virtual void RenderDebug(const Math::Mat4f& _cameraMatrix) const;

					BoundingComponent* Bounding() const;

				protected:
					virtual void UpdateComponent();

				private:
					Lights::SpotLight* light;
					BoundingComponent* bounding;
					Graphic::GraphicContext* context;
				};
			}
		}
	}
}

#endif