#ifndef _ENGINE_SCENE_COMPONENTS_POSITIONCOMPONENT_HPP
#define _ENGINE_SCENE_COMPONENTS_POSITIONCOMPONENT_HPP

#include "../../dllconfig.hpp"
#include "../../Prototypes.hpp"

#include "IComponent.hpp"
#include "../../Math/Math.hpp"

namespace Engine
{
	namespace Scene
	{
		namespace Components
		{
			class _DLL_DECLSPEC PositionComponent : public IComponent
			{
			public:
				PositionComponent(Engine::Scene::SceneObject* _sceneObject);
				~PositionComponent();

				virtual ComponentType GetComponentType();
				static ComponentType ComponentTypeOf(); //Muss immer implementiert werden

				void UpdateRecursive();

				const Math::Mat4f& Matrix() const;
				PositionComponent& Matrix(Math::Mat4f& _matrix);

				const Math::Mat4f& WorldMatrix() const;
				const Math::Vec3f& WorldPosition() const;

				const unsigned int StorageIndex() const;
				void StorageIndex(unsigned int _index);

				const bool NeedUpdate() const;
				void NeedUpdate(bool _value);

				const PositionComponent* ParentPositionComponent() const;

			protected:
				virtual void UpdateComponent();

			private:
				void ComponentsChanged(void* _sender, ComponentChangedEventArgs& _args);
				void ParentChanged(void* _sender, Engine::Scene::ParentChangedEventArgs& _args);

				PositionComponent* parentPositionComponent;

				Math::Mat4f worldMatrix;
				Math::Vec3f worldPosition;
				Math::Mat4f matrix;
				unsigned int storageIndex;
				volatile bool needUpdate;
				
			};
		}
	}
}

#endif