#ifndef _ENGINE_SCENE_COMPONENTS_RENDERCOMPONENT_HPP
#define _ENGINE_SCENE_COMPONENTS_RENDERCOMPONENT_HPP

#include "../../Prototypes.hpp"
#include "IComponent.hpp"
#include "../../Math/Math.hpp"

namespace Engine
{
	namespace Scene
	{
		namespace Components
		{
			class ENGINE_INTERFACE  _DLL_DECLSPEC RenderComponent : public IComponent
			{
			public:
				RenderComponent(Engine::Scene::SceneObject* _sceneObject);
				RenderComponent(Engine::Scene::SceneObject* _sceneObject, const bool _registerUpdate);
				virtual ~RenderComponent();

				virtual void Render(Cameras::Camera* _camera) = 0;
				virtual void RenderNormals(const Math::Mat4f& _cameraMatrix) = 0;
				virtual void RenderOctree(const Math::Mat4f& _cameraMatrixX, const Math::Mat4f& _cameraMatrixY, const Math::Mat4f& _cameraMatrixZ) = 0;

				virtual void RenderDebug(const Math::Mat4f& _cameraMatrix) = 0;

				virtual BoundingComponent* Bounding() const = 0;
			};
		}
	}
}

#endif