#define DLL_EXPORT

#include "DirectionalLight.hpp"
#include <algorithm>

using namespace std;
using namespace Engine;
using namespace Engine::Scene;
using namespace Engine::Scene::Lights;

DirectionalLight::DirectionalLight(const Math::Vec3f& _intensity) : worldDirection(), intensity(_intensity)
{ }

DirectionalLight::~DirectionalLight()
{ }

inline LightType DirectionalLight::GetType() const
{
	return LightType::Directional;
}
				
void DirectionalLight::Update(const Math::Mat4f& _matrix)
{
	worldDirection.X(-_matrix.M13());
	worldDirection.Y(-_matrix.M23());
	worldDirection.Z(-_matrix.M33());
	worldDirection.Normalize();
}

inline const Math::Vec3f& DirectionalLight::WorldDirection() const
{
	return worldDirection;
}

inline const Math::Vec3f& DirectionalLight::Intensity() const
{
	return intensity;
}

inline void DirectionalLight::Intensity(const Math::Vec3f& _value)
{
	intensity = _value;
}

inline float DirectionalLight::GetInfluence(const Math::Vec3f& _target) const
{
	return max(intensity.X(), max(intensity.Y(), intensity.Z()));
}