#ifndef _ENGINE_SCENE_LIGHTS_DIRECTIONALLIGHT_HPP
#define _ENGINE_SCENE_LIGHTS_DIRECTIONALLIGHT_HPP

#include "Light.hpp"
#include "../../Math/Math.hpp"

namespace Engine
{
	namespace Scene
	{
		namespace Lights
		{
			class _DLL_DECLSPEC DirectionalLight : public Light
			{
			public:
				DirectionalLight(const Math::Vec3f& _intensity);
				~DirectionalLight();

				virtual LightType GetType() const;
				
				virtual void Update(const Math::Mat4f& _matrix);

				const Math::Vec3f& WorldDirection() const;

				const Math::Vec3f& Intensity() const;
				void Intensity(const Math::Vec3f& _value);

				virtual float GetInfluence(const Math::Vec3f& _target) const;

			private:
				Math::Vec3f worldDirection;
				Math::Vec3f intensity;

			};
		}
	}
}

#endif