#ifndef _ENGINE_SCENE_LIGHTS_LIGHT_HPP
#define _ENGINE_SCENE_LIGHTS_LIGHT_HPP

#include "../../dllconfig.hpp"
#include "../../Math/Math.hpp"

namespace Engine
{
	namespace Scene
	{
		class SceneObject;

		namespace Lights
		{
			enum LightType { Directional = 0, Point = 1, Spot = 2 };

			class _DLL_DECLSPEC Light
			{
			public:
				Light();
				virtual ~Light();

				virtual LightType GetType() const = 0;
				
				virtual void Update(const Math::Mat4f& _matrix) = 0;

				virtual float GetInfluence(const Math::Vec3f& _target) const = 0;

			};
		}
	}
}

#endif