#ifndef _ENGINE_SCENE_LIGHTS_POINTLIGHT_HPP
#define _ENGINE_SCENE_LIGHTS_POINTLIGHT_HPP

#include "Light.hpp"
#include "../Boundings/Sphere.hpp"

namespace Engine
{
	namespace Scene
	{
		namespace Lights
		{
			class _DLL_DECLSPEC PointLight : public Light
			{
			public:
				PointLight(const Math::Vec3f& _intensity, const Math::Vec3f& _attenuation);

				LightType GetType() const;
				
				void Update(const Math::Mat4f& _matrix);

				const Math::Vec3f& Intensity() const;
				void Intensity(const Math::Vec3f& _value);
				const Math::Vec3f& Attenuation() const;
				void Attenuation(const Math::Vec3f& _value);

				const Math::Vec3f& WorldPosition() const;
				const Math::Mat4f& LightMatrix() const;

				const Boundings::Sphere& Boundings() const;

				virtual float GetInfluence(const Math::Vec3f& _target) const;

			private:
				float CalculateMaximumDistance() const;

				Math::Vec3f intensity, attenuation;
				Math::Vec3f worldPosition;
				Math::Mat4f lightMatrix;

				Boundings::Sphere bounding;
			};
		}
	}
}

#endif