#ifndef _ENGINE_UTIL_CLOCK_HPP
#define _ENGINE_UTIL_CLOCK_HPP

#include "../dllconfig.hpp"

#include <Windows.h>
#include <ctime>

namespace Engine
{
	namespace Util
	{
		class _DLL_DECLSPEC Clock
		{
		public:
			Clock();
			~Clock();

			void Start();
			void Pause();
			void Tick();

			float AbsoluteTime() const;
			float RelativeTime() const;

			bool IsRunning() const;

		private:
			LONGLONG lastStartTime, lastTickTime, tickTime, timerFrequency;
			LONGLONG timeBeforeLastPause;
			double absoluteTime, relativeTime;
			bool isRunning;
		};
	}
}

#endif