#ifndef _ENGINE_UTIL_DEBUGGING_INTERNALDEBUGGER_HPP
#define _ENGINE_UTIL_DEBUGGING_INTERNALDEBUGGER_HPP

#include "../../dllconfig.hpp"
#include "StackFrame.hpp"
#include <string>
#include <vector>

#ifdef _ENGINE_USE_INTERNALDEBUGGING
#pragma comment( lib, "DbgHelp.lib" )
#include <Windows.h>
#include <DbgHelp.h>
#endif

namespace Engine
{
	namespace Util
	{
		namespace Debugging
		{
			class _DLL_DECLSPEC InternalDebugger
			{
			public:
				static void Init();
				static std::vector<StackFrame> GetStackTrace();
				static void PrintStackTrace();
				static void ShutDown();

			private:
				#ifdef _ENGINE_USE_INTERNALDEBUGGING
				static HANDLE process;
				static DWORD processID;
				#endif
			};
		}
	}
}

#endif