#define DLL_EXPORT

#include "StackFrame.hpp"

using namespace Engine;
using namespace Engine::Util;
using namespace Engine::Util::Debugging;

StackFrame::StackFrame() : symbolName(""), assembly(""), filename(""), line(0)
{ }

StackFrame::StackFrame(std::string _symbolName, std::string _assembly, std::string _filename, unsigned int _line) :
	symbolName(_symbolName), assembly(_assembly), filename(_filename), line(_line)
{ }
StackFrame::StackFrame(const StackFrame& _frame) :
	symbolName(_frame.symbolName), assembly(_frame.assembly), filename(_frame.filename), line(_frame.line)
{ }
StackFrame::~StackFrame()
{ }

inline std::string StackFrame::SymbolName() const
{
	return symbolName;
}

inline std::string StackFrame::Assembly() const
{
	return assembly;
}

inline std::string StackFrame::Filename() const
{
	return filename;
}

inline unsigned int StackFrame::Line() const
{
	return line;
}

inline StackFrame& StackFrame::operator=(const StackFrame& _frame)
{
	line = _frame.line;
	symbolName = _frame.symbolName;
	assembly = _frame.assembly;
	filename = _frame.filename;
	return *this;
}