#ifndef _ENGINE_UTIL_DEBUGGING_STACKFRAME_HPP
#define _ENGINE_UTIL_DEBUGGING_STACKFRAME_HPP

#include "../../dllconfig.hpp"

#include <string>

namespace Engine
{
	namespace Util
	{
		namespace Debugging
		{
			class _DLL_DECLSPEC StackFrame
			{
			public:
				StackFrame();
				StackFrame(std::string _symbolName, std::string _assembly, std::string _filename, unsigned int _line);
				StackFrame(const StackFrame& _frame);
				~StackFrame();

				std::string SymbolName() const;
				std::string Assembly() const;
				std::string Filename() const;
				unsigned int Line() const;

				StackFrame& operator = (const StackFrame& _frame);

			private:
				std::string symbolName, assembly, filename;
				unsigned int line;
			};
		}
	}
}

#endif