#ifndef _ENGINE_UTIL_FUNCTIONDECORATOR
#define _ENGINE_UTIL_FUNCTIONDECORATOR

#include "../Core/Control/SystemConsole.hpp"

#define FUNCTIONDECORATOR_START(CLASSNAME) \
	class CLASSNAME ## _functiondecorator \
		{ \
		public:

#define FUNCTIONDECORATOR_FUNCTION_CALLERLOG(CLASSNAME, FUNCTIONNAME, PARAMETER) \
	static void (* ## FUNCTIONNAME (std::string _caller, std::string _file, int _line))( PARAMETER ) \
	{ \
		Engine::Core::Control::SystemConsole::SetColor(Engine::Core::Control::ConsoleColor::DarkGrayConsoleColor); \
		std::cout << " (" << _file << ":" << _line << ") : "; \
		return CLASSNAME ## :: ## FUNCTIONNAME; \
	}

#define FUNCTIONDECORATOR_FUNCTION_CALLERLOG_OPTIONAL(CLASSNAME, FUNCTIONNAME, PARAMETER, OPTIONNAME) \
	static void (* ## FUNCTIONNAME (std::string _caller, std::string _file, int _line))( PARAMETER ) \
	{ \
		if (CLASSNAME ## :: ## OPTIONNAME) \
		{ \
		Engine::Core::Control::SystemConsole::SetColor(Engine::Core::Control::ConsoleColor::DarkGrayConsoleColor); \
		std::cout << " (" << _file << ":" << _line << ") : "; \
		} \
		return CLASSNAME ## :: ## FUNCTIONNAME; \
	} \

#define FUNCTIONDECORATOR_FUNCTION(RETURNTYPE, CLASSNAME, FUNCTIONNAME, PARAMETER) \
	static RETURNTYPE (* ## FUNCTIONNAME (std::string _caller, std::string _file, int _line))( PARAMETER ) \
	{ \
		return CLASSNAME ## :: ## FUNCTIONNAME; \
	} \

#define FUNCTIONDECORATOR_END() \
	};


#endif