#define DLL_EXPORT

#include "GLStopWatch.hpp"

using namespace Engine;
using namespace Engine::Util;

GLStopWatch::GLStopWatch()
{
	glGenQueries(2, queries);
}
GLStopWatch::~GLStopWatch()
{
	glDeleteQueries(2, queries);
}

void GLStopWatch::Start()
{
	glQueryCounter(queries[0], GL_TIMESTAMP);
}
void GLStopWatch::Stop()
{
	glQueryCounter(queries[1], GL_TIMESTAMP);
}

float GLStopWatch::Time()
{
	GLint stopTimerAvailable = 0;
	while (!stopTimerAvailable)
		glGetQueryObjectiv(queries[1], GL_QUERY_RESULT_AVAILABLE, &stopTimerAvailable);

	
	glGetQueryObjectui64v(queries[0], GL_QUERY_RESULT, &timer);
	glGetQueryObjectui64v(queries[1], GL_QUERY_RESULT, &timer2);

	return ((float)(timer2 - timer) / 1000000.0f);
}