#define DLL_EXPORT

#include "StopWatch.hpp"
#include "Logger.hpp"

#include <sstream>
#include <iomanip>

using namespace Engine::Util;

StopWatch::StopWatch(std::string _name) : name(_name)
{
	QueryPerformanceFrequency((LARGE_INTEGER*)&timerFrequency);	
}

StopWatch::~StopWatch()
{	
}

void StopWatch::Start()
{
	QueryPerformanceCounter((LARGE_INTEGER*)&startTime);
}

void StopWatch::Stop()
{
	QueryPerformanceCounter((LARGE_INTEGER*)&endTime);
}

std::string StopWatch::Display(bool _showInConsole)
{
	double duration = (double)(endTime - startTime) / ((double)timerFrequency);
	
	std::stringstream ss;
	ss << name << ": " << std::setprecision(6) << duration * 1000.0 << " ms";

	if (_showInConsole)
		Logger::Debug(ss.str());

	return ss.str();
}

float StopWatch::Time() const
{
	double duration = (double)(endTime - startTime) / ((double)timerFrequency);
	return (float)(duration * 1000.0);
}