#define DLL_EXPORT

#include <Windows.h>

#include "Core\Concurrency\ThreadManager.hpp"

using namespace Engine::Core::Concurrency;

BOOL WINAPI DllMain(HINSTANCE hinst, DWORD reason, LPVOID lpReserved)
{
	switch (reason)
	{
	case DLL_PROCESS_ATTACH:
		{
			//Erstes mal an Programm binden
			//TLS Index generieren
			ThreadManager::tlsIndex = TlsAlloc();
			if (ThreadManager::tlsIndex == TLS_OUT_OF_INDEXES)
				return FALSE;
		}
		//No break, must initialize first thread
	case DLL_THREAD_ATTACH:
		{
			TLSData* data = (TLSData*)LocalAlloc(LPTR, sizeof(TLSData));
			if (data == NULL)
				return FALSE;

			BOOL error = TlsSetValue(ThreadManager::tlsIndex, data);
			if (error == FALSE)
				return FALSE;

			ThreadManager::RegisterThread();
		}
		break;

	case DLL_THREAD_DETACH:
		{
			ThreadManager::ReleaseThread();

			TLSData* data = (TLSData*)TlsGetValue(ThreadManager::tlsIndex);
			if (data != NULL)
				LocalFree(data);
		}
		break;
	case DLL_PROCESS_DETACH:
		{
			TLSData* data = (TLSData*)TlsGetValue(ThreadManager::tlsIndex);
			if (data != NULL)
				LocalFree(data);

			TlsFree(ThreadManager::tlsIndex);
		}
		break;

	default:
		break;
	}

	return TRUE;
}